import { c as K, a as $, t as ee, z as te, p as re, V as X, O as D, f as U, L as ie, G as ae, i as le, a4 as se, a1 as ne, a5 as he, v as oe, a6 as ce, d as de, B as ue, b as ge, q as fe, R as Ie, Q as me, a7 as Ne, r as xe, e as be, a2 as Fe, y as _e, C as Ae, x as ye, a8 as Ce, Z as Le, o as Se, s as ke, w as we, F as Oe, A as Ge, u as ve } from "./index-DCHLGNvJ.js";
import { D as ze } from "./DataTable-Cnr3w23K.js";
import { _ as Me } from "./Title-Dt5mC-vb.js";
import { _ as pe, u as Te } from "./Tooltip-CmKYX0H1.js";
import { U as Pe } from "./usePrinter-BvounINk.js";
import { _ as Ve } from "./Shape-DZz__S1P.js";
import Re from "./BaseIcon-B9BZgZsa.js";
import De from "./vue-ui-table-sparkline-Du93NBKM.js";
import He from "./vue-ui-skeleton-nTL-u4Yd.js";
import { S as Be } from "./Slicer-Clpv-EOL.js";
import We from "./vue-ui-accordion-DEpeQHhr.js";
import { u as Z } from "./useNestedProp-BPR7xHxr.js";
import { _ as Ee } from "./PackageVersion-BAKTtSRE.js";
import { P as Ye } from "./PenAndPaper-BUzmu0vi.js";
import { resolveComponent as R, openBlock as a, createElementBlock as s, normalizeClass as B, normalizeStyle as O, createBlock as H, createCommentVNode as c, createSlots as qe, withCtx as P, renderSlot as S, normalizeProps as W, guardReactiveProps as Y, createVNode as q, createElementVNode as g, Fragment as u, renderList as m, toDisplayString as k, mergeProps as J, createTextVNode as Q, withDirectives as Xe, vModelCheckbox as Ue } from "vue";
import { _ as Ze } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Je = K(), Qe = {
  name: "vue-ui-xy",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  components: {
    DataTable: ze,
    Shape: Ve,
    Title: Me,
    Tooltip: pe,
    UserOptions: Pe,
    BaseIcon: Re,
    TableSparkline: De,
    Skeleton: He,
    Slicer: Be,
    Accordion: We,
    PackageVersion: Ee,
    PenAndPaper: Ye
  },
  data() {
    this.dataset.forEach((d, t) => {
      [null, void 0].includes(d.series) && this.error({
        componentName: "VueUiXy",
        type: "datasetSerieAttribute",
        property: "series (number[])",
        index: t
      });
    });
    const r = this.config.downsample && this.config.downsample.threshold ? this.config.downsample.threshold : 500, l = Math.max(...this.dataset.map((d) => this.largestTriangleThreeBucketsArray({ data: d.series, threshold: r }).length)), o = {
      start: 0,
      end: l
    };
    return {
      themePalettes: $,
      themes: ee,
      slicerStep: 0,
      selectedScale: null,
      CTX: null,
      CANVAS: null,
      opacity: te,
      useSafeValues: !0,
      palette: re,
      height: 600,
      width: 1e3,
      viewBox: "0 0 1000 600",
      clientPosition: {
        x: 0,
        y: 0
      },
      canvasClientPosition: {
        x: 0,
        y: 0
      },
      icons: {
        line: "line",
        bar: "bar",
        plot: "plot"
      },
      isAnnotator: !1,
      isFullscreen: !1,
      isPrinting: !1,
      isImaging: !1,
      isTooltip: !1,
      mutableConfig: {
        dataLabels: {
          show: !0
        },
        showTooltip: !0,
        showTable: !1,
        isStacked: !1,
        useIndividualScale: !1
      },
      selectedSerieIndex: null,
      selectedRowIndex: null,
      segregatedSeries: [],
      uniqueId: K(),
      step: 0,
      tableStep: 0,
      titleStep: 0,
      slicer: o,
      __to__: null,
      maxX: l,
      showSparklineTable: !0,
      segregateStep: 0,
      sliderId: Je,
      fontSizes: {
        xAxis: 18,
        yAxis: 12,
        dataLabels: 20,
        plotLabels: 10
      },
      plotRadii: {
        plot: 3,
        line: 3
      },
      selectedMinimapIndex: null,
      showUserOptionsOnChartHover: !1,
      keepUserOptionState: !0,
      userOptionsVisible: !0
    };
  },
  watch: {
    dataset: {
      handler(r, l) {
        this.maxX = Math.max(...this.dataset.map((o) => this.largestTriangleThreeBucketsArray({
          data: o.series,
          threshold: this.FINAL_CONFIG.downsample.threshold
        }).length)), this.slicer = {
          start: 0,
          end: this.maxX
        }, this.slicerStep += 1, this.segregateStep += 1;
      },
      deep: !0
    },
    config: {
      handler(r, l) {
        this.FINAL_CONFIG = this.prepareConfig(), this.prepareChart(), this.titleStep += 1, this.tableStep += 1, this.mutableConfig = {
          dataLabels: {
            show: !0
          },
          showTooltip: this.FINAL_CONFIG.chart.tooltip.show === !0,
          showTable: this.FINAL_CONFIG.showTable === !0,
          isStacked: this.FINAL_CONFIG.chart.grid.labels.yAxis.stacked,
          useIndividualScale: this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale
        };
      },
      deep: !0
    }
  },
  computed: {
    optimize() {
      return {
        linePlot: this.maxSeries > this.FINAL_CONFIG.line.dot.hideAboveMaxSerieLength
      };
    },
    hasOptionsNoTitle() {
      return this.FINAL_CONFIG.chart.userOptions.show && (!this.FINAL_CONFIG.chart.title.show || !this.FINAL_CONFIG.chart.title.text);
    },
    minimap() {
      if (!this.FINAL_CONFIG.chart.zoom.minimap.show) return [];
      const r = this.datasetWithIds.filter((t) => !this.segregatedSeries.includes(t.id)), l = Math.max(...r.map((t) => t.series.length)), o = [];
      for (let t = 0; t < l; t += 1)
        o.push(r.map((e) => e.series[t] || 0).reduce((e, N) => (e || 0) + (N || 0), 0));
      const d = Math.min(...o);
      return o.map((t) => t + (d < 0 ? Math.abs(d) : 0));
    },
    customPalette() {
      return this.convertCustomPalette(this.FINAL_CONFIG.customPalette);
    },
    backgroundColor() {
      return this.FINAL_CONFIG.chart.backgroundColor;
    },
    slicerColor() {
      return this.FINAL_CONFIG.chart.zoom.color;
    },
    allScales() {
      const r = this.lineSet.map((t) => ({
        name: t.name,
        color: t.color,
        scale: t.individualScale,
        scaleYLabels: t.scaleYLabels,
        zero: t.zeroPosition,
        max: t.individualMax,
        scaleLabel: t.scaleLabel || "",
        id: t.id,
        yOffset: t.yOffset || 0,
        individualHeight: t.individualHeight || this.drawingArea.height,
        autoScaleYLabels: t.autoScaleYLabels
      })), l = this.barSet.map((t) => ({
        name: t.name,
        color: t.color,
        scale: t.individualScale,
        scaleYLabels: t.scaleYLabels,
        zero: t.zeroPosition,
        max: t.individualMax,
        scaleLabel: t.scaleLabel || "",
        id: t.id,
        yOffset: t.yOffset || 0,
        individualHeight: t.individualHeight || this.drawingArea.height
      })), o = this.plotSet.map((t) => ({
        name: t.name,
        color: t.color,
        scale: t.individualScale,
        scaleYLabels: t.scaleYLabels,
        // FIX
        zero: t.zeroPosition,
        max: t.individualMax,
        scaleLabel: t.scaleLabel || "",
        id: t.id,
        yOffset: t.yOffset || 0,
        individualHeight: t.individualHeight || this.drawingArea.height
      })), d = [...r, ...l, ...o].flatMap((t) => t).length;
      return [...r, ...l, ...o].flatMap((t, e) => ({
        id: t.id,
        scaleLabel: t.scaleLabel,
        name: t.name,
        color: t.color,
        scale: t.scale,
        yOffset: t.yOffset,
        individualHeight: t.individualHeight,
        x: this.mutableConfig.isStacked ? this.drawingArea.left : this.drawingArea.left / d * (e + 1),
        yLabels: t.scaleYLabels || t.scale.ticks.map((N) => ({
          y: N >= 0 ? t.zero - t.individualHeight * (N / t.max) : t.zero + t.individualHeight * Math.abs(N) / t.max,
          value: N
        }))
      }));
    },
    isDataset() {
      return !!this.dataset && this.dataset.length;
    },
    chartFont() {
      const r = document.getElementById(`vue-ui-xy_${this.uniqueId}`);
      return window.getComputedStyle(r, null).getPropertyValue("font-family");
    },
    FINAL_CONFIG: {
      get: function() {
        return this.prepareConfig();
      },
      set: function(r) {
        return r;
      }
    },
    hasHighlightArea() {
      return Array.isArray(this.FINAL_CONFIG.chart.highlightArea) ? this.FINAL_CONFIG.chart.highlightArea.some((r) => r.show) : this.FINAL_CONFIG.chart.highlightArea && this.FINAL_CONFIG.chart.highlightArea.show;
    },
    highlightAreas() {
      if (Array.isArray(this.FINAL_CONFIG.chart.highlightArea))
        return this.FINAL_CONFIG.chart.highlightArea.map((l) => ({
          ...l,
          span: l.from === l.to ? 1 : l.to < l.from ? 0 : l.to - l.from + 1
        }));
      const r = this.FINAL_CONFIG.chart.highlightArea;
      return [{ ...r, span: r.from === r.to ? 1 : r.to < r.from ? 0 : r.to - r.from + 1 }];
    },
    xPadding() {
      return this.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : this.drawingArea.width / this.maxSeries / 2;
    },
    relativeZero() {
      return [null, void 0].includes(this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin) ? this.niceScale.min >= 0 ? 0 : Math.abs(this.niceScale.min) : -this.niceScale.min;
    },
    absoluteMax() {
      return this.niceScale.max + this.relativeZero;
    },
    datasetWithIds() {
      return this.useSafeValues ? this.dataset.map((r, l) => ({
        ...r,
        series: this.largestTriangleThreeBucketsArray({
          data: r.series,
          threshold: this.FINAL_CONFIG.downsample.threshold
        }),
        id: `uniqueId_${l}`
      })) : this.dataset;
    },
    safeDataset() {
      return this.useSafeValues ? this.dataset.map((r, l) => {
        const o = this.largestTriangleThreeBucketsArray({
          data: r.series,
          threshold: this.FINAL_CONFIG.downsample.threshold
        });
        return {
          ...r,
          slotAbsoluteIndex: l,
          series: o.map((d) => this.isSafeValue(d) ? d : null).slice(this.slicer.start, this.slicer.end),
          color: this.convertColorToHex(r.color ? r.color : this.customPalette[l] ? this.customPalette[l] : this.palette[l]),
          id: `uniqueId_${l}`
        };
      }) : this.dataset;
    },
    relativeDataset() {
      return this.safeDataset.map((r, l) => ({
        ...r,
        series: r.series.map((o) => o + this.relativeZero),
        absoluteValues: r.series
      })).filter((r) => !this.segregatedSeries.includes(r.id));
    },
    tableSparklineDataset() {
      return this.relativeDataset.map((r) => {
        const l = r.absoluteValues.map((o) => [void 0, null].includes(o) ? 0 : o);
        return {
          id: r.id,
          name: r.name,
          color: r.color,
          values: this.fillArray(this.maxSeries, l)
        };
      });
    },
    tableSparklineConfig() {
      return {
        responsiveBreakpoint: this.FINAL_CONFIG.table.responsiveBreakpoint,
        roundingValues: this.FINAL_CONFIG.table.rounding,
        showAverage: !1,
        showMedian: !1,
        showTotal: !1,
        fontFamily: this.FINAL_CONFIG.chart.fontFamily,
        prefix: this.FINAL_CONFIG.chart.labels.prefix,
        suffix: this.FINAL_CONFIG.chart.labels.suffix,
        colNames: JSON.parse(JSON.stringify(this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values)),
        thead: {
          backgroundColor: this.FINAL_CONFIG.table.th.backgroundColor,
          color: this.FINAL_CONFIG.table.th.color,
          outline: this.FINAL_CONFIG.table.th.outline
        },
        tbody: {
          backgroundColor: this.FINAL_CONFIG.table.td.backgroundColor,
          color: this.FINAL_CONFIG.table.td.color,
          outline: this.FINAL_CONFIG.table.td.outline
        },
        userOptions: {
          show: !1
        }
      };
    },
    absoluteDataset() {
      return this.safeDataset.map((r, l) => ({
        absoluteIndex: l,
        ...r,
        series: r.series.map((o) => o + this.relativeZero),
        absoluteValues: r.series,
        segregate: () => this.segregate(r),
        isSegregated: this.segregatedSeries.includes(r.id)
      }));
    },
    barSet() {
      return this.activeSeriesWithStackRatios.filter((r) => r.type === "bar").map((r, l) => {
        this.checkAutoScaleError(r);
        const o = Math.min(...r.absoluteValues.filter((x) => ![null, void 0].includes(x))), d = Math.max(...r.absoluteValues.filter((x) => ![null, void 0].includes(x))), e = {
          ratios: r.absoluteValues.filter((x) => ![null, void 0].includes(x)).map((x) => (x - o) / (d - o)),
          valueMin: o,
          valueMax: d < 0 ? 0 : d
        }, N = {
          max: r.scaleMax || Math.max(...r.absoluteValues) || 1,
          min: r.scaleMin || Math.min(...r.absoluteValues.filter((x) => ![void 0, null].includes(x))) > 0 ? 0 : Math.min(...r.absoluteValues.filter((x) => ![null, void 0].includes(x)))
        }, _ = r.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, w = 1.0000001, I = this.calculateNiceScaleWithExactExtremes(N.min, N.max === N.min ? N.max * w : N.max, _), b = this.calculateNiceScaleWithExactExtremes(e.valueMin, e.valueMax === e.valueMin ? e.valueMax * w : e.valueMax, _), V = I.min >= 0 ? 0 : Math.abs(I.min), v = 0, z = I.max + V, G = b.max + Math.abs(v), F = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - r.cumulatedStackRatio) : 0, C = this.mutableConfig.isStacked ? this.drawingArea.height * r.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, T = this.drawingArea.bottom - F - C * V / z, i = this.drawingArea.bottom - F - C * v / G, h = this.absoluteDataset.filter((x) => x.type === "bar").filter((x) => !this.segregatedSeries.includes(x.id)).length, n = r.series.map((x, p) => {
          const y = this.mutableConfig.useIndividualScale ? (r.absoluteValues[p] + V) / z : this.ratioToMax(x), L = this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.drawingArea.left + this.drawingArea.width / this.maxSeries * p : this.drawingArea.left + this.slot.bar * l + this.slot.bar * p * h - this.barSlot / 2 - l * this.barPeriodGap;
          return {
            yOffset: this.checkNaN(F),
            individualHeight: this.checkNaN(C),
            x: this.checkNaN(L),
            y: this.drawingArea.bottom - F - C * y,
            value: r.absoluteValues[p],
            zeroPosition: this.checkNaN(T),
            individualMax: this.checkNaN(z),
            comment: r.comments && r.comments.slice(this.slicer.start, this.slicer.end)[p] || ""
          };
        }), f = r.absoluteValues.map((x) => b.min >= 0 ? (x - Math.abs(b.min)) / (b.max - Math.abs(b.min)) : (x + Math.abs(b.min)) / (b.max + Math.abs(b.min))), E = r.series.map((x, p) => {
          const y = this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.drawingArea.left + this.drawingArea.width / this.maxSeries * p : this.drawingArea.left - this.slot.bar / 2 + this.slot.bar * l + this.slot.bar * p * this.absoluteDataset.filter((L) => L.type === "bar").filter((L) => !this.segregatedSeries.includes(L.id)).length;
          return {
            yOffset: this.checkNaN(F),
            individualHeight: this.checkNaN(C),
            x: this.checkNaN(y),
            y: this.checkNaN(this.drawingArea.bottom - this.checkNaN(F) - (this.checkNaN(C) * f[p] || 0)),
            value: r.absoluteValues[p],
            zeroPosition: this.checkNaN(T),
            individualMax: this.checkNaN(z),
            comment: r.comments && r.comments.slice(this.slicer.start, this.slicer.end)[p] || ""
          };
        }), A = I.ticks.map((x) => ({
          y: x >= 0 ? T - C * (x / z) : T + C * Math.abs(x) / z,
          value: x,
          prefix: r.prefix || this.FINAL_CONFIG.chart.labels.prefix,
          suffix: r.suffix || this.FINAL_CONFIG.chart.labels.suffix,
          datapoint: r
        })), M = b.ticks.map((x) => {
          const p = (x - b.min) / (b.max - b.min);
          return {
            y: x >= 0 ? i - C * p : i + C * p,
            value: x,
            prefix: r.prefix || this.FINAL_CONFIG.chart.labels.prefix,
            suffix: r.suffix || this.FINAL_CONFIG.chart.labels.suffix,
            datapoint: r
          };
        });
        return {
          ...r,
          yOffset: F,
          autoScaleYLabels: M,
          individualHeight: C,
          scaleYLabels: r.autoScaling ? M : A,
          individualScale: r.autoScaling ? b : I,
          individualMax: r.autoScaling ? G : z,
          zeroPosition: r.autoScaling ? i : T,
          plots: r.autoScaling ? E : n
        };
      });
    },
    activeSeriesLength() {
      return this.absoluteDataset.length;
    },
    activeSeriesWithStackRatios() {
      return this.assignStackRatios(this.absoluteDataset.filter((r) => !this.segregatedSeries.includes(r.id)));
    },
    lineSet() {
      return this.activeSeriesWithStackRatios.filter((r) => r.type === "line").map((r) => {
        this.checkAutoScaleError(r);
        const l = Math.min(...r.absoluteValues.filter((y) => ![void 0, null].includes(y))), o = Math.max(...r.absoluteValues.filter((y) => ![void 0, null].includes(y))) || 1, t = {
          ratios: r.absoluteValues.filter((y) => ![null, void 0].includes(y)).map((y) => (y - l) / (o - l)),
          valueMin: l,
          valueMax: o
        }, e = {
          max: r.scaleMax || Math.max(...r.absoluteValues) || 1,
          min: r.scaleMin || (Math.min(...r.absoluteValues) > 0 ? 0 : Math.min(...r.absoluteValues))
        }, N = r.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, _ = 1.0000001, w = this.calculateNiceScaleWithExactExtremes(e.min, e.max === e.min ? e.max * _ : e.max, N), I = this.calculateNiceScaleWithExactExtremes(t.valueMin, t.valueMax === t.valueMin ? t.valueMax * _ : t.valueMax, N), b = w.min >= 0 ? 0 : Math.abs(w.min), V = 0, v = w.max + Math.abs(b), z = I.max + Math.abs(V), G = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - r.cumulatedStackRatio) : 0, F = this.mutableConfig.isStacked ? this.drawingArea.height * r.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, C = this.drawingArea.bottom - G - F * b / v, T = this.drawingArea.bottom - G - F * V / z, i = r.series.map((y, L) => {
          const j = this.mutableConfig.useIndividualScale ? (r.absoluteValues[L] + Math.abs(b)) / v : this.ratioToMax(y);
          return {
            x: this.checkNaN(this.drawingArea.left + this.slot.line / 2 + this.slot.line * L),
            y: this.checkNaN(this.drawingArea.bottom - G - F * j),
            value: r.absoluteValues[L],
            comment: r.comments && r.comments.slice(this.slicer.start, this.slicer.end)[L] || ""
          };
        }), h = r.absoluteValues.map((y) => I.min >= 0 ? (y - Math.abs(I.min)) / (I.max - Math.abs(I.min)) : (y + Math.abs(I.min)) / (I.max + Math.abs(I.min))), n = r.series.map((y, L) => [void 0, null].includes(r.absoluteValues[L]) ? {
          x: this.checkNaN(this.drawingArea.left + this.slot.line / 2 + this.slot.line * L),
          y: C,
          value: r.absoluteValues[L],
          comment: r.comments && r.comments.slice(this.slicer.start, this.slicer.end)[L] || ""
        } : {
          x: this.checkNaN(this.drawingArea.left + this.slot.line / 2 + this.slot.line * L),
          y: this.checkNaN(this.drawingArea.bottom - G - (F * h[L] || 0)),
          value: r.absoluteValues[L],
          comment: r.comments && r.comments.slice(this.slicer.start, this.slicer.end)[L] || ""
        }), f = this.createSmoothPath(i), E = this.createSmoothPath(n), A = this.createStraightPath(i), M = this.createStraightPath(n), x = w.ticks.map((y) => ({
          y: y >= 0 ? C - F * (y / v) : C + F * Math.abs(y) / v,
          value: y,
          prefix: r.prefix || this.FINAL_CONFIG.chart.labels.prefix,
          suffix: r.suffix || this.FINAL_CONFIG.chart.labels.suffix,
          datapoint: r
        })), p = I.ticks.map((y) => {
          const L = (y - I.min) / (I.max - I.min);
          return {
            y: y >= 0 ? T - F * L : T + F * L,
            value: y,
            prefix: r.prefix || this.FINAL_CONFIG.chart.labels.prefix,
            suffix: r.suffix || this.FINAL_CONFIG.chart.labels.suffix,
            datapoint: r
          };
        });
        return {
          ...r,
          yOffset: G,
          autoScaleYLabels: p,
          individualHeight: F,
          scaleYLabels: r.autoScaling ? p : x,
          individualScale: r.autoScaling ? I : w,
          individualMax: r.autoScaling ? z : v,
          zeroPosition: r.autoScaling ? T : C,
          curve: r.autoScaling ? E : f,
          plots: r.autoScaling ? n : i,
          area: r.useArea ? this.mutableConfig.useIndividualScale ? this.createIndividualArea(r.autoScaling ? n : i, r.autoScaling ? T : C) : this.createArea(i) : "",
          straight: r.autoScaling ? M : A
        };
      });
    },
    plotSet() {
      return this.activeSeriesWithStackRatios.filter((r) => r.type === "plot").map((r) => {
        this.checkAutoScaleError(r);
        const l = Math.min(...r.absoluteValues.filter((A) => ![null, void 0].includes(A))), o = Math.max(...r.absoluteValues.filter((A) => ![null, void 0].includes(A))) || 1, t = {
          ratios: r.absoluteValues.filter((A) => ![null, void 0].includes(A)).map((A) => (A - l) / (o - l)),
          valueMin: l,
          valueMax: o
        }, e = {
          max: r.scaleMax || Math.max(...r.absoluteValues) || 1,
          min: r.scaleMin || Math.min(...r.absoluteValues) > 0 ? 0 : Math.min(...r.absoluteValues)
        }, N = r.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, _ = 1.0000001, w = this.calculateNiceScaleWithExactExtremes(e.min, e.max === e.min ? e.max * _ : e.max, N), I = this.calculateNiceScaleWithExactExtremes(t.valueMin, t.valueMax === t.valueMin ? t.valueMax * _ : t.valueMax, N), b = w.min >= 0 ? 0 : Math.abs(w.min), V = 0, v = w.max + b, z = I.max + Math.abs(V), G = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - r.cumulatedStackRatio) : 0, F = this.mutableConfig.isStacked ? this.drawingArea.height * r.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, C = this.drawingArea.bottom - G - F * b / v, T = this.drawingArea.bottom - G - F * V / z, i = r.series.map((A, M) => {
          const x = this.mutableConfig.useIndividualScale ? (r.absoluteValues[M] + Math.abs(b)) / v : this.ratioToMax(A);
          return {
            x: this.checkNaN(this.drawingArea.left + this.slot.plot / 2 + this.slot.plot * M),
            y: this.checkNaN(this.drawingArea.bottom - G - F * x),
            value: r.absoluteValues[M],
            comment: r.comments && r.comments.slice(this.slicer.start, this.slicer.end)[M] || ""
          };
        }), h = r.absoluteValues.map((A) => I.min >= 0 ? (A - Math.abs(I.min)) / (I.max - Math.abs(I.min)) : (A + Math.abs(I.min)) / (I.max + Math.abs(I.min))), n = r.series.map((A, M) => ({
          x: this.checkNaN(this.drawingArea.left + this.slot.plot / 2 + this.slot.plot * M),
          y: this.checkNaN(this.drawingArea.bottom - G - (F * h[M] || 0)),
          value: r.absoluteValues[M],
          comment: r.comments && r.comments.slice(this.slicer.start, this.slicer.end)[M] || ""
        })), f = w.ticks.map((A) => ({
          y: A >= 0 ? C - F * (A / v) : C + F * Math.abs(A) / v,
          value: A,
          prefix: r.prefix || this.FINAL_CONFIG.chart.labels.prefix,
          suffix: r.suffix || this.FINAL_CONFIG.chart.labels.suffix,
          datapoint: r
        })), E = I.ticks.map((A) => {
          const M = (A - I.min) / (I.max - I.min);
          return {
            y: A >= 0 ? T - F * M : T + F * M,
            value: A,
            prefix: r.prefix || this.FINAL_CONFIG.chart.labels.prefix,
            suffix: r.suffix || this.FINAL_CONFIG.chart.labels.suffix,
            datapoint: r
          };
        });
        return {
          ...r,
          yOffset: G,
          autoScaleYLabels: E,
          individualHeight: F,
          scaleYLabels: r.autoScaling ? E : f,
          individualScale: r.autoScaling ? I : w,
          individualMax: r.autoScaling ? z : v,
          zeroPosition: r.autoScaling ? T : C,
          plots: r.autoScaling ? n : i
        };
      });
    },
    drawingArea() {
      const r = this.mutableConfig.useIndividualScale && this.FINAL_CONFIG.chart.grid.labels.show ? this.absoluteDataset.filter((l) => !this.segregatedSeries.includes(l.id)).length * (this.mutableConfig.isStacked ? 0 : this.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth) : 0;
      return {
        top: this.FINAL_CONFIG.chart.padding.top,
        right: this.width - this.FINAL_CONFIG.chart.padding.right,
        bottom: this.height - this.FINAL_CONFIG.chart.padding.bottom,
        left: this.FINAL_CONFIG.chart.padding.left + r,
        height: this.height - (this.FINAL_CONFIG.chart.padding.top + this.FINAL_CONFIG.chart.padding.bottom),
        width: this.width - (this.FINAL_CONFIG.chart.padding.right + this.FINAL_CONFIG.chart.padding.left + r)
      };
    },
    max() {
      return this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMax ? this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMax : Math.max(...this.safeDataset.filter((r) => !this.segregatedSeries.includes(r.id)).map((r) => Math.max(...r.series)));
    },
    min() {
      if (this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin !== null)
        return this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin;
      const r = Math.min(...this.safeDataset.filter((l) => !this.segregatedSeries.includes(l.id)).map((l) => Math.min(...l.series)));
      return r > 0 ? 0 : r;
    },
    niceScale() {
      return this.calculateNiceScaleWithExactExtremes(this.min, this.max < 0 ? 0 : this.max, this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps);
    },
    maxSeries() {
      return this.slicer.end - this.slicer.start;
    },
    timeLabels() {
      const r = Math.max(...this.dataset.map((o) => this.largestTriangleThreeBucketsArray({ data: o.series, threshold: this.FINAL_CONFIG.downsample.threshold }).length)), l = [];
      for (let o = 0; o < r; o += 1)
        l.push({
          text: this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[o] || String(o),
          absoluteIndex: o
        });
      return l.slice(this.slicer.start, this.slicer.end);
    },
    slot() {
      return {
        bar: this.drawingArea.width / this.maxSeries / this.safeDataset.filter((r) => r.type === "bar").filter((r) => !this.segregatedSeries.includes(r.id)).length,
        plot: this.drawingArea.width / this.maxSeries,
        line: this.drawingArea.width / this.maxSeries
      };
    },
    barSlot() {
      const r = this.safeDataset.filter((l) => l.type === "bar").filter((l) => !this.segregatedSeries.includes(l.id)).length;
      return this.drawingArea.width / this.maxSeries / r - this.barPeriodGap * r;
    },
    barPeriodGap() {
      return this.slot.line * this.FINAL_CONFIG.bar.periodGap;
    },
    maxSlot() {
      return Math.max(...Object.values(this.slot).filter((r) => r !== 1 / 0));
    },
    table() {
      if (this.safeDataset.length === 0) return { head: [], body: [], config: {}, columnNames: [] };
      const r = this.relativeDataset.map((o) => ({
        label: o.name,
        color: o.color,
        type: o.type
      })), l = [];
      return this.timeLabels.forEach((o, d) => {
        const t = [o.text];
        this.relativeDataset.forEach((e) => {
          t.push(this.canShowValue(e.absoluteValues[d]) ? Number(e.absoluteValues[d].toFixed(this.FINAL_CONFIG.table.rounding)) : "");
        }), l.push(t);
      }), { head: r, body: l };
    },
    dataTable() {
      const r = this.FINAL_CONFIG.table.showSum;
      let l = [""].concat(this.relativeDataset.map((e) => e.name));
      r && (l = l.concat(' <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"/><path d="M18 16v2a1 1 0 0 1 -1 1h-11l6 -7l-6 -7h11a1 1 0 0 1 1 1v2" /></svg>'));
      let o = [];
      for (let e = 0; e < this.maxSeries; e += 1) {
        const N = this.relativeDataset.map((_) => _.absoluteValues[e] ?? 0).reduce((_, w) => _ + w, 0);
        o.push(
          [
            this.timeLabels[e].text ?? "-"
          ].concat(this.relativeDataset.map(
            (_) => this.applyDataLabel(
              _.type === "line" ? this.FINAL_CONFIG.line.labels.formatter : _.type === "bar" ? this.FINAL_CONFIG.bar.labels.formatter : this.FINAL_CONFIG.plot.labels.formatter,
              _.absoluteValues[e] ?? 0,
              this.dataLabel({
                p: _.prefix || this.FINAL_CONFIG.chart.labels.prefix,
                v: _.absoluteValues[e] ?? 0,
                s: _.suffix || this.FINAL_CONFIG.chart.labels.suffix,
                r: this.FINAL_CONFIG.table.rounding
              })
            )
          )).concat(r ? (N ?? 0).toFixed(this.FINAL_CONFIG.table.rounding) : [])
        );
      }
      const d = {
        th: {
          backgroundColor: this.FINAL_CONFIG.table.th.backgroundColor,
          color: this.FINAL_CONFIG.table.th.color,
          outline: this.FINAL_CONFIG.table.th.outline
        },
        td: {
          backgroundColor: this.FINAL_CONFIG.table.td.backgroundColor,
          color: this.FINAL_CONFIG.table.td.color,
          outline: this.FINAL_CONFIG.table.td.outline
        },
        breakpoint: this.FINAL_CONFIG.table.responsiveBreakpoint
      }, t = [this.FINAL_CONFIG.table.columnNames.period].concat(this.relativeDataset.map((e) => e.name)).concat(this.FINAL_CONFIG.table.columnNames.total);
      return { head: l, body: o, config: d, colNames: t };
    },
    dataTooltipSlot() {
      return {
        datapoint: this.selectedSeries,
        seriesIndex: this.selectedSerieIndex,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      };
    },
    selectedSeries() {
      return this.relativeDataset.map((r) => ({
        slotAbsoluteIndex: r.slotAbsoluteIndex,
        shape: r.shape || null,
        name: r.name,
        color: r.color,
        type: r.type,
        value: r.absoluteValues.find((l, o) => o === this.selectedSerieIndex),
        comments: r.comments || [],
        prefix: r.prefix || this.FINAL_CONFIG.chart.labels.prefix,
        suffix: r.suffix || this.FINAL_CONFIG.chart.labels.suffix
      }));
    },
    tooltipContent() {
      let r = "", l = this.selectedSeries.map((t) => t.value).filter((t) => this.isSafeValue(t) && t !== null).reduce((t, e) => Math.abs(t) + Math.abs(e), 0);
      const o = this.timeLabels[this.selectedSerieIndex], d = this.FINAL_CONFIG.chart.tooltip.customFormat;
      return this.isFunction(d) && this.functionReturnsString(() => d({
        seriesIndex: this.selectedSerieIndex,
        datapoint: this.selectedSeries,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      })) ? d({
        seriesIndex: this.selectedSerieIndex,
        datapoint: this.selectedSeries,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      }) : (o && o.text && this.FINAL_CONFIG.chart.tooltip.showTimeLabel && (r += `<div style="padding-bottom: 6px; margin-bottom: 4px; border-bottom: 1px solid ${this.FINAL_CONFIG.chart.tooltip.borderColor}; width:100%">${o.text}</div>`), this.selectedSeries.forEach((t) => {
        if (this.isSafeValue(t.value)) {
          let e = "", N = "";
          switch (this.icons[t.type]) {
            case "bar":
              e = `<svg viewBox="0 0 40 40" height="14" width="14">${this.$slots.pattern ? `<rect x="0" y="0" rx="1" stroke="none" height="40" width="40" fill="${t.color}" />` : ""}<rect x="0" y="0" rx="1" stroke="none" height="40" width="40" fill="${this.$slots.pattern ? `url(#pattern_${this.uniqueId}_${t.slotAbsoluteIndex}` : t.color}" /></svg>`;
              break;
            case "line":
              !t.shape || !["star", "triangle", "square", "diamond", "pentagon", "hexagon"].includes(t.shape) ? N = `<circle cx="10" cy="8" r="4" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" fill="${t.color}" />` : t.shape === "triangle" ? N = `<path d="${D({ plot: { x: 10, y: 8 }, radius: 4, sides: 3, rotation: 0.52 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : t.shape === "square" ? N = `<path d="${D({ plot: { x: 10, y: 8 }, radius: 4, sides: 4, rotation: 0.8 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : t.shape === "diamond" ? N = `<path d="${D({ plot: { x: 10, y: 8 }, radius: 4, sides: 4, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : t.shape === "pentagon" ? N = `<path d="${D({ plot: { x: 10, y: 8 }, radius: 4, sides: 5, rotation: 0.95 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : t.shape === "hexagon" ? N = `<path d="${D({ plot: { x: 10, y: 8 }, radius: 4, sides: 6, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : t.shape === "star" && (N = `<polygon stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" fill="${t.color}" points="${X({ plot: { x: 10, y: 8 }, radius: 4 })}" />`), e = `<svg viewBox="0 0 20 12" height="14" width="20"><rect rx="1.5" x="0" y="6.5" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" height="3" width="20" fill="${t.color}" />${N}</svg>`;
              break;
            case "plot":
              if (!t.shape || !["star", "triangle", "square", "diamond", "pentagon", "hexagon"].includes(t.shape)) {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><circle cx="6" cy="6" r="6" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${t.color}" /></svg>`;
                break;
              }
              if (t.shape === "star") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><polygon stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${t.color}" points="${X({ plot: { x: 6, y: 6 }, radius: 5 })}" /></svg>`;
                break;
              }
              if (t.shape === "triangle") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${D({ plot: { x: 6, y: 6 }, radius: 6, sides: 3, rotation: 0.52 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "square") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${D({ plot: { x: 6, y: 6 }, radius: 6, sides: 4, rotation: 0.8 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "diamond") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${D({ plot: { x: 6, y: 6 }, radius: 5, sides: 4, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "pentagon") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${D({ plot: { x: 6, y: 6 }, radius: 5, sides: 5, rotation: 0.95 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "hexagon") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${D({ plot: { x: 6, y: 6 }, radius: 5, sides: 6, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
          }
          r += `<div style="display:flex;flex-direction:row; align-items:center;gap:3px;"><div style="width:20px">${e}</div> ${t.name}: <b>${this.FINAL_CONFIG.chart.tooltip.showValue ? this.applyDataLabel(
            t.type === "line" ? this.FINAL_CONFIG.line.labels.formatter : t.type === "bar" ? this.FINAL_CONFIG.bar.labels.formatter : this.FINAL_CONFIG.plot.labels.formatter,
            t.value,
            this.dataLabel({
              p: t.prefix,
              v: t.value,
              s: t.suffix,
              r: this.FINAL_CONFIG.chart.tooltip.roundingValue
            }),
            { datapoint: t }
          ) : ""}</b> ${this.FINAL_CONFIG.chart.tooltip.showPercentage ? `(${U({
            v: this.checkNaN(Math.abs(t.value) / l * 100),
            s: "%",
            r: this.FINAL_CONFIG.chart.tooltip.roundingPercentage
          })})` : ""}</div>`, this.FINAL_CONFIG.chart.comments.showInTooltip && t.comments.length && t.comments.slice(this.slicer.start, this.slicer.end)[this.selectedSerieIndex] && (r += `<div class="vue-data-ui-tooltip-comment" style="background:${t.color}20; padding: 6px; margin-bottom: 6px; border-left: 1px solid ${t.color}">${t.comments.slice(this.slicer.start, this.slicer.end)[this.selectedSerieIndex]}</div>`);
        }
      }), `<div style="border-radius:4px;padding:12px;font-variant-numeric: tabular-nums;color:${this.FINAL_CONFIG.chart.tooltip.color}">${r}</div>`);
    },
    svg() {
      return {
        height: this.height,
        width: this.width
      };
    },
    yLabels() {
      return this.niceScale.ticks.map((r) => ({
        y: r >= 0 ? this.zero - this.drawingArea.height * this.ratioToMax(r) : this.zero + this.drawingArea.height * this.ratioToMax(Math.abs(r)),
        value: r,
        prefix: this.FINAL_CONFIG.chart.labels.prefix,
        suffix: this.FINAL_CONFIG.chart.labels.suffix
      }));
    },
    zero() {
      return this.drawingArea.bottom - this.drawingArea.height * this.ratioToMax(this.relativeZero);
    }
  },
  mounted() {
    this.prepareChart(), this.setupSlicer(), document.addEventListener("mousemove", (r) => {
      this.clientPosition = {
        x: r.clientX,
        y: r.clientY
      };
    });
  },
  methods: {
    abbreviate: ie,
    adaptColorToBackground: ae,
    applyDataLabel: le,
    assignStackRatios: se,
    calcLinearProgression: ne,
    calculateNiceScaleWithExactExtremes: he,
    checkNaN: oe,
    closestDecimal: ce,
    convertColorToHex: de,
    convertConfigColors: ue,
    convertCustomPalette: ge,
    createCsvContent: fe,
    createSmoothPath: Ie,
    createStraightPath: me,
    createTSpans: Ne,
    dataLabel: U,
    downloadCsv: xe,
    error: be,
    forceValidValue: Fe,
    functionReturnsString: _e,
    hasDeepProperty: Ae,
    isFunction: ye,
    isSafeValue: Ce,
    largestTriangleThreeBucketsArray: Le,
    objectIsEmpty: Se,
    setOpacity: ke,
    shiftHue: we,
    translateSize: Oe,
    treeShake: Ge,
    useMouse: Te,
    useNestedProp: Z,
    setUserOptionsVisibility(r = !1) {
      this.showUserOptionsOnChartHover && (this.userOptionsVisible = r);
    },
    toggleAnnotator() {
      this.isAnnotator = !this.isAnnotator;
    },
    selectTimeLabel(r, l) {
      const o = this.relativeDataset.map((d) => ({
        shape: d.shape || null,
        name: d.name,
        color: d.color,
        type: d.type,
        value: d.absoluteValues.find((t, e) => e === l),
        comments: d.comments || [],
        prefix: d.prefix || this.FINAL_CONFIG.chart.labels.prefix,
        suffix: d.suffix || this.FINAL_CONFIG.chart.labels.suffix
      }));
      this.$emit("selectTimeLabel", {
        datapoint: o,
        absoluteIndex: r.absoluteIndex,
        label: r.text
      });
    },
    getHighlightAreaPosition(r) {
      const l = this.drawingArea.left + this.drawingArea.width / this.maxSeries * (r.from - this.slicer.start), o = this.drawingArea.width / (this.slicer.end - this.slicer.start) * r.span < 0 ? 1e-5 : this.drawingArea.width / (this.slicer.end - this.slicer.start) * r.span;
      return {
        x: l < this.drawingArea.left ? this.drawingArea.left : l,
        width: o
      };
    },
    prepareConfig() {
      const r = ve().vue_ui_xy;
      if (!Object.keys(this.config || {}).length)
        return r;
      const l = this.useNestedProp({
        userConfig: this.config,
        defaultConfig: r
      });
      return this.config && this.hasDeepProperty(this.config, "chart.highlightArea") && (Array.isArray(this.config.chart.highlightArea) ? l.chart.highlightArea = this.config.chart.highlightArea : l.chart.highlightArea = [this.config.chart.highlightArea]), this.config && this.hasDeepProperty(this.config, "chart.grid.labels.yAxis.scaleMin") ? l.chart.grid.labels.yAxis.scaleMin = this.config.chart.grid.labels.yAxis.scaleMin : l.chart.grid.labels.yAxis.scaleMin = null, this.config && this.hasDeepProperty(this.config, "chart.grid.labels.yAxis.scaleMax") ? l.chart.grid.labels.yAxis.scaleMax = this.config.chart.grid.labels.yAxis.scaleMax : l.chart.grid.labels.yAxis.scaleMax = null, this.config && this.hasDeepProperty(this.config, "chart.zoom.startIndex") ? l.chart.zoom.startIndex = this.config.chart.zoom.startIndex : l.chart.zoom.startIndex = null, this.config && this.hasDeepProperty(this.config, "chart.zoom.endIndex") ? l.chart.zoom.endIndex = this.config.chart.zoom.endIndex : l.chart.zoom.endIndex = null, l.theme ? {
        ...Z({
          userConfig: this.themes.vue_ui_xy[l.theme] || this.config,
          defaultConfig: l
        }),
        customPalette: this.themePalettes[l.theme] || this.palette
      } : l;
    },
    prepareChart() {
      if (this.objectIsEmpty(this.dataset) ? this.error({
        componentName: "VueUiXy",
        type: "dataset"
      }) : this.dataset.forEach((r, l) => {
        [null, void 0].includes(r.name) && this.error({
          componentName: "VueUiXy",
          type: "datasetSerieAttribute",
          property: "name (string)",
          index: l
        });
      }), this.FINAL_CONFIG.showWarnings && this.dataset.forEach((r) => {
        r.series.forEach((l, o) => {
          this.isSafeValue(l) || console.warn(`VueUiXy has detected an unsafe value in your dataset:
-----> The serie '${r.name}' contains the value '${l}' at index ${o}.
'${l}' was converted to null to allow the chart to display.`);
        });
      }), this.showUserOptionsOnChartHover = this.FINAL_CONFIG.chart.userOptions.showOnChartHover, this.keepUserOptionState = this.FINAL_CONFIG.chart.userOptions.keepStateOnChartLeave, this.userOptionsVisible = !this.FINAL_CONFIG.chart.userOptions.showOnChartHover, this.mutableConfig = {
        dataLabels: {
          show: !0
        },
        showTooltip: this.FINAL_CONFIG.chart.tooltip.show === !0,
        showTable: this.FINAL_CONFIG.showTable === !0,
        isStacked: this.FINAL_CONFIG.chart.grid.labels.yAxis.stacked,
        useIndividualScale: this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale
      }, this.FINAL_CONFIG.responsive) {
        const l = this.$refs.chart.parentNode, { height: o, width: d } = l.getBoundingClientRect();
        let t = null, e = 0;
        this.FINAL_CONFIG.chart.title.show && (t = this.$refs.chartTitle, e = t.getBoundingClientRect().height);
        let N = null, _ = 0;
        this.FINAL_CONFIG.chart.zoom.show && this.maxX > 6 && this.isDataset && (N = this.$refs.chartSlicer.$el, _ = N.getBoundingClientRect().height);
        let w = null, I = 0;
        this.FINAL_CONFIG.chart.legend.show && (w = this.$refs.chartLegend, I = w.getBoundingClientRect().height);
        let b = 0;
        this.$refs.source && (b = this.$refs.source.getBoundingClientRect().height);
        let V = 0;
        this.$refs.noTitle && (V = this.$refs.noTitle.getBoundingClientRect().height), this.height = o - e - I - _ - b - V, this.width = d, this.viewBox = `0 0 ${this.width < 0 ? 10 : this.width} ${this.height < 0 ? 10 : this.height}`, this.convertSizes(), new ResizeObserver((z) => {
          for (const G of z)
            this.$refs.chartTitle && (e = this.$refs.chartTitle.getBoundingClientRect().height), this.$refs.chartSlicer && this.$refs.chartSlicer.$el && (_ = this.$refs.chartSlicer.$el.getBoundingClientRect().height), this.$refs.chartLegend && (I = this.$refs.chartLegend.getBoundingClientRect().height), this.$refs.source && (b = this.$refs.source.getBoundingClientRect().height), requestAnimationFrame(() => {
              this.height = G.contentBoxSize[0].blockSize - e - I - _ - b - 24, this.width = G.contentBoxSize[0].inlineSize, this.viewBox = `0 0 ${this.width < 0 ? 10 : this.width} ${this.height < 0 ? 10 : this.height}`, this.convertSizes();
            });
        }).observe(l);
      } else
        this.height = this.FINAL_CONFIG.chart.height, this.width = this.FINAL_CONFIG.chart.width, this.viewBox = `0 0 ${this.width} ${this.height}`, this.fontSizes.dataLabels = this.FINAL_CONFIG.chart.grid.labels.fontSize, this.fontSizes.yAxis = this.FINAL_CONFIG.chart.grid.labels.axis.fontSize, this.fontSizes.xAxis = this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.fontSize, this.fontSizes.plotLabels = this.FINAL_CONFIG.chart.labels.fontSize, this.plotRadii.plot = this.FINAL_CONFIG.plot.radius, this.plotRadii.line = this.FINAL_CONFIG.line.radius;
    },
    selectMinimapIndex(r) {
      this.selectedMinimapIndex = r;
    },
    convertSizes() {
      this.fontSizes.dataLabels = this.translateSize({
        relator: this.height,
        adjuster: 400,
        source: this.FINAL_CONFIG.chart.grid.labels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.yAxis = this.translateSize({
        relator: this.width,
        adjuster: 1e3,
        source: this.FINAL_CONFIG.chart.grid.labels.axis.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.xAxis = this.translateSize({
        relator: this.width,
        adjuster: 1e3,
        source: this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.plotLabels = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.chart.labels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.plotRadii.plot = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.plot.radius,
        threshold: 1,
        fallback: 1
      }), this.plotRadii.line = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.line.radius,
        threshold: 1,
        fallback: 1
      });
    },
    toggleStack() {
      this.mutableConfig.isStacked = !this.mutableConfig.isStacked, this.mutableConfig.isStacked ? this.mutableConfig.useIndividualScale = !0 : this.mutableConfig.useIndividualScale = this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale;
    },
    toggleTable() {
      this.mutableConfig.showTable = !this.mutableConfig.showTable;
    },
    toggleLabels() {
      this.mutableConfig.dataLabels.show = !this.mutableConfig.dataLabels.show;
    },
    toggleTooltip() {
      this.mutableConfig.showTooltip = !this.mutableConfig.showTooltip;
    },
    checkAutoScaleError(r) {
      r.autoScaling && (this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale || console.warn(`VueUiXy (datapoint: ${r.name}) : autoScaling only works when config.chart.grid.labels.yAxis.useIndividualScale is set to true`), this.FINAL_CONFIG.chart.grid.labels.yAxis.stacked || console.warn(`VueUiXy (datapoint: ${r.name}) : autoScaling only works when config.chart.grid.labels.yAxis.stacked is set to true`));
    },
    createArea(r) {
      if (!r[0]) return [-10, -10, "", -10, -10];
      const l = { x: r[0].x, y: this.zero }, o = { x: r.at(-1).x, y: this.zero }, d = [];
      return r.forEach((t) => {
        d.push(`${t.x},${t.y} `);
      }), [l.x, l.y, ...d, o.x, o.y].toString();
    },
    createIndividualArea(r, l) {
      if (!r[0]) return [-10, -10, "", -10, -10];
      const o = { x: r[0] ? r[0].x : Math.min(...r.filter((e) => !!e).map((e) => e.x)), y: l }, d = { x: r.at(-1) ? r.at(-1).x : Math.min(...r.filter((e) => !!e).map((e) => e.x)), y: l }, t = [];
      return r.filter((e) => !!e).forEach((e) => {
        t.push(`${e.x},${e.y} `);
      }), [o.x, o.y, ...t, d.x, d.y].toString();
    },
    createStar: X,
    createPolygonPath: D,
    fillArray(r, l) {
      let o = Array(r).fill(0);
      for (let d = 0; d < l.length && d < r; d += 1)
        o[d] = l[d];
      return o;
    },
    async setupSlicer() {
      (this.FINAL_CONFIG.chart.zoom.startIndex !== null || this.FINAL_CONFIG.chart.zoom.endIndex !== null) && this.$refs.chartSlicer ? (this.FINAL_CONFIG.chart.zoom.startIndex !== null && (await this.$nextTick(), await this.$nextTick(), this.$refs.chartSlicer.setStartValue(this.FINAL_CONFIG.chart.zoom.startIndex)), this.FINAL_CONFIG.chart.zoom.endIndex !== null && (await this.$nextTick(), await this.$nextTick(), this.$refs.chartSlicer.setEndValue(this.validSlicerEnd(this.FINAL_CONFIG.chart.zoom.endIndex + 1)))) : (this.slicer = {
        start: 0,
        end: Math.max(...this.dataset.map((r) => this.largestTriangleThreeBucketsArray({ data: r.series, threshold: this.FINAL_CONFIG.downsample.threshold }).length))
      }, this.slicerStep += 1);
    },
    refreshSlicer() {
      this.setupSlicer();
    },
    validSlicerEnd(r) {
      const l = Math.max(...this.dataset.map((o) => this.largestTriangleThreeBucketsArray({ data: o.series, threshold: this.FINAL_CONFIG.downsample.threshold }).length));
      return r > l ? l : r < 0 || this.FINAL_CONFIG.chart.zoom.startIndex !== null && r < this.FINAL_CONFIG.chart.zoom.startIndex ? this.FINAL_CONFIG.chart.zoom.startIndex !== null ? this.FINAL_CONFIG.chart.zoom.startIndex + 1 : 1 : r;
    },
    calcRectHeight(r) {
      const l = ![null, void 0].includes(this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin) && this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin > 0 && this.min >= 0 ? this.drawingArea.bottom : this.zero;
      return r.value >= 0 ? this.checkNaN(l - r.y <= 0 ? 1e-5 : l - r.y) : this.checkNaN(r.y - this.zero <= 0 ? 1e-5 : r.y - this.zero);
    },
    calcIndividualHeight(r) {
      return r.value >= 0 ? this.checkNaN(r.zeroPosition - r.y <= 0 ? 1e-5 : r.zeroPosition - r.y) : this.checkNaN(r.y - r.zeroPosition <= 0 ? 1e-5 : r.zeroPosition - r.y);
    },
    calcRectWidth() {
      return this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.slot.line - this.drawingArea.width / this.maxSeries * 0.1 : this.slot.bar;
    },
    calcRectX(r) {
      return this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? r.x + this.drawingArea.width / this.maxSeries * 0.05 : r.x + this.slot.bar / 2;
    },
    calcRectY(r) {
      return r.value >= 0 ? r.y : this.zero;
    },
    calcIndividualRectY(r) {
      return r.value >= 0 ? r.y : [null, void 0, NaN, 1 / 0, -1 / 0].includes(r.zeroPosition) ? 0 : r.zeroPosition;
    },
    canShowValue(r) {
      return ![null, void 0, NaN, 1 / 0, -1 / 0].includes(r);
    },
    findClosestValue(r, l) {
      let o = l[0], d = Math.abs(r - l[0]);
      for (let t = 1; t < l.length; t += 1) {
        const e = Math.abs(r - l[t]);
        e < d && l[t] < r && (o = l[t], d = e);
      }
      return o;
    },
    ratioToMax(r) {
      return r / (this.canShowValue(this.absoluteMax) ? this.absoluteMax : 1);
    },
    selectX(r) {
      this.$emit(
        "selectX",
        {
          dataset: this.relativeDataset.map((l) => ({
            name: l.name,
            value: [null, void 0, NaN].includes(l.absoluteValues[r]) ? null : l.absoluteValues[r],
            color: l.color,
            type: l.type
          })),
          index: r,
          indexLabel: this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[r]
        }
      );
    },
    getData() {
      return this.absoluteDataset.map((r) => ({
        values: r.absoluteValues,
        color: r.color,
        name: r.name,
        type: r.type
      }));
    },
    segregate(r) {
      if (this.segregatedSeries.includes(r.id))
        this.segregatedSeries = this.segregatedSeries.filter((l) => l !== r.id);
      else {
        if (this.segregatedSeries.length + 1 === this.safeDataset.length) return;
        this.segregatedSeries.push(r.id);
      }
      this.$emit("selectLegend", this.relativeDataset.map((l) => ({
        name: l.name,
        values: l.absoluteValues,
        color: l.color,
        type: l.type
      }))), this.segregateStep += 1;
    },
    toggleTooltipVisibility(r, l = null) {
      this.isTooltip = r, r ? this.selectedSerieIndex = l : this.selectedSerieIndex = null;
    },
    toggleFullscreen(r) {
      this.isFullscreen = r, this.step += 1;
    },
    showSpinnerPdf() {
      this.isPrinting = !0;
    },
    async generatePdf() {
      this.showSpinnerPdf(), clearTimeout(this.__to__), this.isPrinting = !0, this.__to__ = setTimeout(async () => {
        try {
          const { default: r } = await import("./pdf-B7oVat64.js");
          await r({
            domElement: document.getElementById(`vue-ui-xy_${this.uniqueId}`),
            fileName: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy"
          });
        } catch (r) {
          console.error("Error generating PDF:", r);
        } finally {
          this.isPrinting = !1;
        }
      }, 100);
    },
    generateCsv() {
      const r = [[this.FINAL_CONFIG.chart.title.text], [this.FINAL_CONFIG.chart.title.subtitle.text], [""]], l = ["", ...this.table.head.map((e) => e.label)], o = this.table.body, d = r.concat([l]).concat(o), t = this.createCsvContent(d);
      this.downloadCsv({ csvContent: t, title: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy" });
    },
    showSpinnerImage() {
      this.isImaging = !0;
    },
    async generateImage() {
      this.showSpinnerImage(), clearTimeout(this.__to__), this.isImaging = !0, this.__to__ = setTimeout(async () => {
        try {
          const { default: r } = await import("./img-DGzWcJ4Y.js");
          await r({
            domElement: document.getElementById(`vue-ui-xy_${this.uniqueId}`),
            fileName: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy",
            format: "png"
          });
        } catch (r) {
          console.error("Error generating image:", r);
        } finally {
          this.isImaging = !1;
        }
      }, 100);
    }
  }
}, Ke = ["id"], je = {
  key: 1,
  ref: "noTitle",
  class: "vue-data-ui-no-title-space",
  style: "height:36px; width: 100%; background:transparent"
}, $e = ["viewBox"], et = ["x", "y", "width", "height"], tt = { key: 1 }, rt = { class: "vue-ui-xy-grid" }, it = ["stroke", "x1", "x2", "y1", "y2"], at = ["stroke", "x1", "x2", "y1", "y2"], lt = { key: 1 }, st = ["x1", "x2", "y1", "y2", "stroke"], nt = ["x1", "x2", "y1", "y2", "stroke"], ht = ["x1", "x2", "y1", "y2", "stroke"], ot = { key: 3 }, ct = ["x1", "x2", "y1", "y2", "stroke"], dt = ["id"], ut = ["stop-color"], gt = ["stop-color"], ft = ["stop-color"], It = ["id"], mt = ["stop-color"], Nt = ["stop-color"], xt = ["stop-color"], bt = ["id"], Ft = ["stop-color"], _t = ["stop-color"], At = ["id"], yt = ["stop-color"], Ct = ["stop-color"], Lt = ["id"], St = ["stop-color"], kt = ["stop-color"], wt = ["x", "y", "height", "width", "fill"], Ot = ["x", "y", "width"], Gt = ["x", "y", "height", "width", "fill"], vt = ["x", "y", "height", "width", "rx", "fill", "stroke", "stroke-width"], zt = ["x", "y", "height", "width", "rx", "fill", "stroke", "stroke-width"], Mt = ["width", "x", "y"], pt = { key: 0 }, Tt = ["id"], Pt = ["fill"], Vt = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], Rt = ["x", "y", "font-size", "fill"], Dt = ["stroke", "x1", "x2", "y1", "y2"], Ht = { key: 2 }, Bt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], Wt = ["x", "y", "width", "height", "stroke", "stroke-width", "stroke-linecap", "stroke-linejoin", "stroke-dasharray"], Et = { key: 4 }, Yt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], qt = ["fill", "font-size", "transform"], Xt = ["x1", "x2", "y1", "y2", "stroke"], Ut = ["x", "y", "font-size", "fill"], Zt = ["x1", "x2", "y1", "y2", "stroke"], Jt = ["x", "y", "font-size", "fill"], Qt = ["width", "x", "y"], Kt = { style: { width: "100%" } }, jt = { key: 0 }, $t = ["id"], er = ["fill"], tr = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], rr = ["x", "y", "font-size", "fill"], ir = ["d", "stroke", "stroke-width", "stroke-dasharray"], ar = ["d", "stroke", "stroke-width", "stroke-dasharray"], lr = { key: 5 }, sr = { key: 0 }, nr = ["d", "fill"], hr = ["d", "fill"], or = ["d", "fill"], cr = ["d", "fill"], dr = ["d", "stroke", "stroke-width", "stroke-dasharray"], ur = ["d", "stroke", "stroke-width", "stroke-dasharray"], gr = ["width", "x", "y"], fr = { style: { width: "100%" } }, Ir = { key: 3 }, mr = ["id"], Nr = ["fill"], xr = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], br = ["x", "y", "font-size", "fill"], Fr = { key: 6 }, _r = ["x", "y", "font-size", "fill"], Ar = ["x", "y", "font-size", "fill", "font-weight"], yr = { key: 7 }, Cr = ["x", "y", "font-size", "fill"], Lr = ["x", "y"], Sr = ["x", "y"], kr = { key: 8 }, wr = ["x", "y", "font-size", "fill"], Or = ["x", "y"], Gr = ["x", "y"], vr = ["x", "y", "font-size", "fill", "innerHTML"], zr = ["x", "y", "font-size", "fill", "innerHTML"], Mr = ["x", "y", "font-size", "fill", "innerHTML"], pr = ["x", "y", "font-size", "fill", "innerHTML"], Tr = ["x", "y", "width", "height", "fill", "onMouseenter"], Pr = ["font-size", "fill", "transform"], Vr = ["x", "y", "font-size", "fill"], Rr = { key: 10 }, Dr = ["text-anchor", "font-size", "fill", "transform", "onClick"], Hr = ["x", "y", "height", "width", "onMouseenter", "onClick"], Br = {
  key: 11,
  style: { "pointer-events": "none" }
}, Wr = ["x", "y"], Er = ["cx", "cy", "r", "fill"], Yr = {
  key: 5,
  class: "vue-data-ui-watermark"
}, qr = ["onClick"], Xr = {
  key: 0,
  viewBox: "0 0 20 12",
  height: "14",
  width: "20"
}, Ur = ["stroke", "fill"], Zr = {
  key: 1,
  viewBox: "0 0 40 40",
  height: "14",
  width: "14"
}, Jr = ["fill"], Qr = ["fill"], Kr = {
  key: 2,
  viewBox: "0 0 12 12",
  height: "14",
  width: "14"
}, jr = {
  key: 9,
  ref: "chartLegend"
}, $r = {
  key: 10,
  ref: "source",
  dir: "auto"
}, ei = {
  style: { display: "flex", "flex-direction": "row", gap: "6px", "align-items": "center", "padding-left": "6px" },
  "data-html2canvas-ignore": ""
}, ti = ["innerHTML"];
function ri(r, l, o, d, t, e) {
  const N = R("PenAndPaper"), _ = R("Title"), w = R("UserOptions"), I = R("PackageVersion"), b = R("Shape"), V = R("Skeleton"), v = R("Slicer"), z = R("Tooltip"), G = R("BaseIcon"), F = R("TableSparkline"), C = R("DataTable"), T = R("Accordion");
  return a(), s("div", {
    id: `vue-ui-xy_${t.uniqueId}`,
    class: B(`vue-ui-xy ${t.isFullscreen ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.FINAL_CONFIG.useCssAnimation ? "" : "vue-ui-dna"}`),
    ref: "chart",
    style: O(`background:${e.FINAL_CONFIG.chart.backgroundColor}; color:${e.FINAL_CONFIG.chart.color};width:100%;font-family:${e.FINAL_CONFIG.chart.fontFamily};${e.FINAL_CONFIG.responsive ? "height: 100%" : ""}`),
    onMouseenter: l[7] || (l[7] = () => e.setUserOptionsVisibility(!0)),
    onMouseleave: l[8] || (l[8] = () => e.setUserOptionsVisibility(!1))
  }, [
    e.FINAL_CONFIG.chart.userOptions.buttons.annotator ? (a(), H(N, {
      key: 0,
      parent: r.$refs.chart,
      backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
      color: e.FINAL_CONFIG.chart.color,
      active: t.isAnnotator,
      onClose: e.toggleAnnotator
    }, null, 8, ["parent", "backgroundColor", "color", "active", "onClose"])) : c("", !0),
    e.hasOptionsNoTitle ? (a(), s("div", je, null, 512)) : c("", !0),
    e.FINAL_CONFIG.chart.title.show ? (a(), s("div", {
      key: 2,
      ref: "chartTitle",
      class: "vue-ui-xy-title",
      style: O(`font-family:${e.FINAL_CONFIG.chart.fontFamily}`)
    }, [
      (a(), H(_, {
        key: `title_${t.titleStep}`,
        config: {
          title: {
            cy: "xy-div-title",
            ...e.FINAL_CONFIG.chart.title
          },
          subtitle: {
            cy: "xy-div-subtitle",
            ...e.FINAL_CONFIG.chart.title.subtitle
          }
        }
      }, null, 8, ["config"]))
    ], 4)) : c("", !0),
    e.FINAL_CONFIG.chart.userOptions.show && e.isDataset && (t.keepUserOptionState || t.userOptionsVisible) ? (a(), H(w, {
      ref: "defails",
      key: `user_options_${t.step}`,
      backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
      color: e.FINAL_CONFIG.chart.color,
      isPrinting: t.isPrinting,
      isImaging: t.isImaging,
      uid: t.uniqueId,
      hasTooltip: e.FINAL_CONFIG.chart.userOptions.buttons.tooltip && e.FINAL_CONFIG.chart.tooltip.show,
      hasPdf: e.FINAL_CONFIG.chart.userOptions.buttons.pdf,
      hasXls: e.FINAL_CONFIG.chart.userOptions.buttons.csv,
      hasImg: e.FINAL_CONFIG.chart.userOptions.buttons.img,
      hasLabel: e.FINAL_CONFIG.chart.userOptions.buttons.labels,
      hasTable: e.FINAL_CONFIG.chart.userOptions.buttons.table,
      hasStack: o.dataset.length > 1 && e.FINAL_CONFIG.chart.userOptions.buttons.stack,
      hasFullscreen: e.FINAL_CONFIG.chart.userOptions.buttons.fullscreen,
      isStacked: t.mutableConfig.isStacked,
      isFullscreen: t.isFullscreen,
      chartElement: r.$refs.chart,
      position: e.FINAL_CONFIG.chart.userOptions.position,
      isTooltip: t.mutableConfig.showTooltip,
      titles: { ...e.FINAL_CONFIG.chart.userOptions.buttonTitles },
      hasAnnotator: e.FINAL_CONFIG.chart.userOptions.buttons.annotator,
      isAnnotation: t.isAnnotator,
      onToggleFullscreen: e.toggleFullscreen,
      onGeneratePdf: e.generatePdf,
      onGenerateCsv: e.generateCsv,
      onGenerateImage: e.generateImage,
      onToggleTable: e.toggleTable,
      onToggleLabels: e.toggleLabels,
      onToggleStack: e.toggleStack,
      onToggleTooltip: e.toggleTooltip,
      onToggleAnnotator: e.toggleAnnotator,
      style: O({
        visibility: t.keepUserOptionState ? t.userOptionsVisible ? "visible" : "hidden" : "visible"
      })
    }, qe({ _: 2 }, [
      r.$slots.optionTooltip ? {
        name: "optionTooltip",
        fn: P(() => [
          S(r.$slots, "optionTooltip", {}, void 0, !0)
        ]),
        key: "0"
      } : void 0,
      r.$slots.optionPdf ? {
        name: "optionPdf",
        fn: P(() => [
          S(r.$slots, "optionPdf", {}, void 0, !0)
        ]),
        key: "1"
      } : void 0,
      r.$slots.optionCsv ? {
        name: "optionCsv",
        fn: P(() => [
          S(r.$slots, "optionCsv", {}, void 0, !0)
        ]),
        key: "2"
      } : void 0,
      r.$slots.optionImg ? {
        name: "optionImg",
        fn: P(() => [
          S(r.$slots, "optionImg", {}, void 0, !0)
        ]),
        key: "3"
      } : void 0,
      r.$slots.optionTable ? {
        name: "optionTable",
        fn: P(() => [
          S(r.$slots, "optionTable", {}, void 0, !0)
        ]),
        key: "4"
      } : void 0,
      r.$slots.optionLabels ? {
        name: "optionLabels",
        fn: P(() => [
          S(r.$slots, "optionLabels", {}, void 0, !0)
        ]),
        key: "5"
      } : void 0,
      r.$slots.optionStack ? {
        name: "optionStack",
        fn: P(() => [
          S(r.$slots, "optionStack", {}, void 0, !0)
        ]),
        key: "6"
      } : void 0,
      r.$slots.optionFullscreen ? {
        name: "optionFullscreen",
        fn: P(({ toggleFullscreen: i, isFullscreen: h }) => [
          S(r.$slots, "optionFullscreen", W(Y({ toggleFullscreen: i, isFullscreen: h })), void 0, !0)
        ]),
        key: "7"
      } : void 0,
      r.$slots.optionAnnotator ? {
        name: "optionAnnotator",
        fn: P(({ toggleAnnotator: i, isAnnotator: h }) => [
          S(r.$slots, "optionAnnotator", W(Y({ toggleAnnotator: i, isAnnotator: h })), void 0, !0)
        ]),
        key: "8"
      } : void 0
    ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasXls", "hasImg", "hasLabel", "hasTable", "hasStack", "hasFullscreen", "isStacked", "isFullscreen", "chartElement", "position", "isTooltip", "titles", "hasAnnotator", "isAnnotation", "onToggleFullscreen", "onGeneratePdf", "onGenerateCsv", "onGenerateImage", "onToggleTable", "onToggleLabels", "onToggleStack", "onToggleTooltip", "onToggleAnnotator", "style"])) : c("", !0),
    e.isDataset ? (a(), s("svg", {
      key: 4,
      xmlns: "http://www.w3.org/2000/svg",
      class: B([{ "vue-data-ui-fullscreen--on": t.isFullscreen, "vue-data-ui-fulscreen--off": !t.isFullscreen }, "vue-ui-xy-svg"]),
      width: "100%",
      viewBox: t.viewBox,
      style: O(`background: transparent; color:${e.FINAL_CONFIG.chart.color}; font-family:${e.FINAL_CONFIG.chart.fontFamily}`)
    }, [
      q(I),
      r.$slots["chart-background"] ? (a(), s("foreignObject", {
        key: 0,
        x: e.drawingArea.left + e.xPadding < 0 ? 0 : e.drawingArea.left + e.xPadding,
        y: e.drawingArea.top,
        width: e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries) < 0 ? 0 : e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries),
        height: e.drawingArea.height < 0 ? 0 : e.drawingArea.height,
        style: {
          pointerEvents: "none"
        }
      }, [
        S(r.$slots, "chart-background", {}, void 0, !0)
      ], 8, et)) : c("", !0),
      e.maxSeries > 0 ? (a(), s("g", tt, [
        g("g", rt, [
          e.FINAL_CONFIG.chart.grid.labels.xAxis.showBaseline ? (a(), s("line", {
            key: 0,
            stroke: e.FINAL_CONFIG.chart.grid.stroke,
            "stroke-width": "1",
            x1: e.drawingArea.left + e.xPadding,
            x2: e.drawingArea.right - e.xPadding,
            y1: e.forceValidValue(e.drawingArea.bottom),
            y2: e.forceValidValue(e.drawingArea.bottom),
            "stroke-linecap": "round"
          }, null, 8, it)) : c("", !0),
          t.mutableConfig.useIndividualScale ? e.FINAL_CONFIG.chart.grid.showHorizontalLines ? (a(!0), s(u, { key: 2 }, m(e.allScales, (i) => (a(), s("g", null, [
            i.id === t.selectedScale && i.yLabels.length ? (a(!0), s(u, { key: 0 }, m(i.yLabels, (h) => (a(), s("line", {
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.right - e.xPadding,
              y1: e.forceValidValue(h.y),
              y2: e.forceValidValue(h.y),
              stroke: i.color,
              "stroke-width": 0.5,
              "stroke-linecap": "round"
            }, null, 8, nt))), 256)) : i.yLabels.length ? (a(!0), s(u, { key: 1 }, m(i.yLabels, (h) => (a(), s("line", {
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.right - e.xPadding,
              y1: e.forceValidValue(h.y),
              y2: e.forceValidValue(h.y),
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": 0.5,
              "stroke-linecap": "round"
            }, null, 8, ht))), 256)) : c("", !0)
          ]))), 256)) : c("", !0) : (a(), s(u, { key: 1 }, [
            e.FINAL_CONFIG.chart.grid.labels.yAxis.showBaseline ? (a(), s("line", {
              key: 0,
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": "1",
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.left + e.xPadding,
              y1: e.forceValidValue(e.drawingArea.top),
              y2: e.forceValidValue(e.drawingArea.bottom),
              "stroke-linecap": "round"
            }, null, 8, at)) : c("", !0),
            e.FINAL_CONFIG.chart.grid.showHorizontalLines ? (a(), s("g", lt, [
              (a(!0), s(u, null, m(e.yLabels, (i) => (a(), s("line", {
                x1: e.drawingArea.left + e.xPadding,
                x2: e.drawingArea.right - e.xPadding,
                y1: e.forceValidValue(i.y),
                y2: e.forceValidValue(i.y),
                stroke: e.FINAL_CONFIG.chart.grid.stroke,
                "stroke-width": 0.5,
                "stroke-linecap": "round"
              }, null, 8, st))), 256))
            ])) : c("", !0)
          ], 64)),
          e.FINAL_CONFIG.chart.grid.showVerticalLines ? (a(), s("g", ot, [
            (a(!0), s(u, null, m(e.maxSeries + (e.FINAL_CONFIG.chart.grid.position === "middle" ? 1 : 0), (i, h) => (a(), s("line", {
              key: `grid_vertical_line_${h}`,
              x1: e.drawingArea.width / e.maxSeries * h + e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.width / e.maxSeries * h + e.drawingArea.left + e.xPadding,
              y1: e.forceValidValue(e.drawingArea.top),
              y2: e.forceValidValue(e.drawingArea.bottom),
              "stroke-width": "0.5",
              stroke: e.FINAL_CONFIG.chart.grid.stroke
            }, null, 8, ct))), 128))
          ])) : c("", !0)
        ]),
        (a(!0), s(u, null, m(e.barSet, (i, h) => (a(), s("defs", {
          key: `def_rect_${h}`
        }, [
          g("linearGradient", {
            id: `rectGradient_pos_${h}_${t.uniqueId}`,
            x2: "0%",
            y2: "100%"
          }, [
            g("stop", {
              offset: "0%",
              "stop-color": i.color
            }, null, 8, ut),
            g("stop", {
              offset: "62%",
              "stop-color": `${e.shiftHue(i.color, 0.02)}`
            }, null, 8, gt),
            g("stop", {
              offset: "100%",
              "stop-color": `${e.shiftHue(i.color, 0.05)}`
            }, null, 8, ft)
          ], 8, dt),
          g("linearGradient", {
            id: `rectGradient_neg_${h}_${t.uniqueId}`,
            x2: "0%",
            y2: "100%"
          }, [
            g("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(i.color, 0.05)}`
            }, null, 8, mt),
            g("stop", {
              offset: "38%",
              "stop-color": `${e.shiftHue(i.color, 0.02)}`
            }, null, 8, Nt),
            g("stop", {
              offset: "100%",
              "stop-color": i.color
            }, null, 8, xt)
          ], 8, It)
        ]))), 128)),
        (a(!0), s(u, null, m(e.plotSet, (i, h) => (a(), s("defs", {
          key: `def_plot_${h}`
        }, [
          g("radialGradient", {
            id: `plotGradient_${h}_${t.uniqueId}`,
            cx: "50%",
            cy: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            g("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(i.color, 0.05)}`
            }, null, 8, Ft),
            g("stop", {
              offset: "100%",
              "stop-color": i.color
            }, null, 8, _t)
          ], 8, bt)
        ]))), 128)),
        (a(!0), s(u, null, m(e.lineSet, (i, h) => (a(), s("defs", {
          key: `def_line_${h}`
        }, [
          g("radialGradient", {
            id: `lineGradient_${h}_${t.uniqueId}`,
            cx: "50%",
            cy: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            g("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(i.color, 0.05)}`
            }, null, 8, yt),
            g("stop", {
              offset: "100%",
              "stop-color": i.color
            }, null, 8, Ct)
          ], 8, At),
          g("linearGradient", {
            id: `areaGradient_${h}_${t.uniqueId}`,
            x1: "0%",
            x2: "100%",
            y1: "0%",
            y2: "0%"
          }, [
            g("stop", {
              offset: "0%",
              "stop-color": `${e.setOpacity(e.shiftHue(i.color, 0.03), e.FINAL_CONFIG.line.area.opacity)}`
            }, null, 8, St),
            g("stop", {
              offset: "100%",
              "stop-color": `${e.setOpacity(i.color, e.FINAL_CONFIG.line.area.opacity)}`
            }, null, 8, kt)
          ], 8, Lt)
        ]))), 128)),
        (a(!0), s(u, null, m(e.highlightAreas, (i) => (a(), s("g", null, [
          i.show ? (a(!0), s(u, { key: 0 }, m(i.span, (h, n) => (a(), s("g", null, [
            g("rect", {
              style: O({
                transition: "none",
                opacity: i.from + n >= t.slicer.start && i.from + n <= t.slicer.end - 1 ? 1 : 0
              }),
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (i.from + n - t.slicer.start),
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
              fill: e.setOpacity(i.color, i.opacity)
            }, null, 12, wt),
            i.caption.text && n === 0 ? (a(), s("foreignObject", {
              key: 0,
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (i.from + n - t.slicer.start) - (i.caption.width === "auto" ? 0 : i.caption.width / 2 - e.drawingArea.width / e.maxSeries * i.span / 2),
              y: e.drawingArea.top + i.caption.offsetY,
              style: O({
                overflow: "visible",
                opacity: i.to >= t.slicer.start && i.from < t.slicer.end ? 1 : 0
              }),
              height: "1",
              width: i.caption.width === "auto" ? e.drawingArea.width / e.maxSeries * i.span : i.caption.width
            }, [
              g("div", {
                style: O(`padding:${i.caption.padding}px;text-align:${i.caption.textAlign};font-size:${i.caption.fontSize}px;color:${i.caption.color};font-weight:${i.caption.bold ? "bold" : "normal"}`)
              }, k(i.caption.text), 5)
            ], 12, Ot)) : c("", !0)
          ]))), 256)) : c("", !0)
        ]))), 256)),
        g("g", null, [
          (a(!0), s(u, null, m(e.maxSeries, (i, h) => (a(), s("g", {
            key: `tooltip_trap_highlighter_${h}`
          }, [
            g("rect", {
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * h,
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
              fill: [t.selectedMinimapIndex, t.selectedSerieIndex, t.selectedRowIndex].includes(h) ? e.setOpacity(e.FINAL_CONFIG.chart.highlighter.color, e.FINAL_CONFIG.chart.highlighter.opacity) : "transparent"
            }, null, 8, Gt)
          ]))), 128))
        ]),
        e.barSet.length ? (a(!0), s(u, { key: 0 }, m(e.barSet, (i, h) => (a(), s("g", {
          key: `serie_bar_${h}`,
          class: B(`serie_bar_${h}`),
          style: O(`opacity:${t.selectedScale ? t.selectedScale === i.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (a(!0), s(u, null, m(i.plots, (n, f) => (a(), s("g", {
            key: `bar_plot_${h}_${f}`
          }, [
            e.canShowValue(n.value) ? (a(), s("rect", {
              key: 0,
              x: e.calcRectX(n),
              y: t.mutableConfig.useIndividualScale ? e.calcIndividualRectY(n) : e.calcRectY(n),
              height: t.mutableConfig.useIndividualScale ? Math.abs(e.calcIndividualHeight(n)) : Math.abs(e.calcRectHeight(n)),
              width: e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap) < 0 ? 1e-5 : e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap),
              rx: e.FINAL_CONFIG.bar.borderRadius,
              fill: e.FINAL_CONFIG.bar.useGradient ? n.value >= 0 ? `url(#rectGradient_pos_${h}_${t.uniqueId})` : `url(#rectGradient_neg_${h}_${t.uniqueId})` : i.color,
              stroke: e.FINAL_CONFIG.bar.border.useSerieColor ? i.color : e.FINAL_CONFIG.bar.border.stroke,
              "stroke-width": e.FINAL_CONFIG.bar.border.strokeWidth
            }, null, 8, vt)) : c("", !0),
            e.canShowValue(n.value) && r.$slots.pattern ? (a(), s("rect", {
              key: 1,
              x: e.calcRectX(n),
              y: t.mutableConfig.useIndividualScale ? e.calcIndividualRectY(n) : e.calcRectY(n),
              height: t.mutableConfig.useIndividualScale ? Math.abs(e.calcIndividualHeight(n)) : Math.abs(e.calcRectHeight(n)),
              width: e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap) < 0 ? 1e-5 : e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap),
              rx: e.FINAL_CONFIG.bar.borderRadius,
              fill: `url(#pattern_${t.uniqueId}_${i.slotAbsoluteIndex})`,
              stroke: e.FINAL_CONFIG.bar.border.useSerieColor ? i.color : e.FINAL_CONFIG.bar.border.stroke,
              "stroke-width": e.FINAL_CONFIG.bar.border.strokeWidth
            }, null, 8, zt)) : c("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (a(), s("foreignObject", {
              key: 2,
              style: { overflow: "visible" },
              height: "12",
              width: (e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap) < 0 ? 1e-5 : e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap) / 2) + e.FINAL_CONFIG.chart.comments.width,
              x: e.calcRectX(n) - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: e.checkNaN(n.y) + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              S(r.$slots, "plot-comment", {
                plot: { ...n, color: i.color, seriesIndex: h, datapointIndex: f }
              }, void 0, !0)
            ], 8, Mt)) : c("", !0)
          ]))), 128)),
          Object.hasOwn(i, "useProgression") && i.useProgression === !0 && !isNaN(e.calcLinearProgression(i.plots).trend) ? (a(), s("g", pt, [
            g("defs", null, [
              g("marker", {
                id: `bar_arrow_${h}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                g("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: i.color
                }, null, 8, Pt)
              ], 8, Tt)
            ]),
            i.plots.length > 1 ? (a(), s("line", {
              key: 0,
              x1: e.calcLinearProgression(i.plots).x1,
              x2: e.calcLinearProgression(i.plots).x2,
              y1: e.forceValidValue(e.calcLinearProgression(i.plots).y1),
              y2: e.forceValidValue(e.calcLinearProgression(i.plots).y2),
              "stroke-width": 1,
              stroke: i.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#bar_arrow_${h})`
            }, null, 8, Vt)) : c("", !0),
            i.plots.length > 1 ? (a(), s("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(i.plots).x2,
              y: e.calcLinearProgression(i.plots).y2 - 6,
              "font-size": t.fontSizes.plotLabels,
              fill: i.color
            }, k(e.dataLabel({
              v: e.calcLinearProgression(i.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, Rt)) : c("", !0)
          ])) : c("", !0)
        ], 6))), 128)) : c("", !0),
        !t.mutableConfig.useIndividualScale && e.FINAL_CONFIG.chart.grid.labels.zeroLine.show ? (a(), s("line", {
          key: 1,
          stroke: e.FINAL_CONFIG.chart.grid.stroke,
          "stroke-width": "1",
          x1: e.drawingArea.left + e.xPadding,
          x2: e.drawingArea.right - e.xPadding,
          y1: e.forceValidValue(e.zero),
          y2: e.forceValidValue(e.zero),
          "stroke-linecap": "round"
        }, null, 8, Dt)) : c("", !0),
        e.FINAL_CONFIG.chart.highlighter.useLine && (![null, void 0].includes(t.selectedSerieIndex) || ![null, void 0].includes(t.selectedMinimapIndex)) ? (a(), s("g", Ht, [
          g("line", {
            x1: e.drawingArea.left + e.drawingArea.width / e.maxSeries * ((t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)) + e.drawingArea.width / e.maxSeries / 2,
            x2: e.drawingArea.left + e.drawingArea.width / e.maxSeries * ((t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)) + e.drawingArea.width / e.maxSeries / 2,
            y1: e.forceValidValue(e.drawingArea.top),
            y2: e.forceValidValue(e.drawingArea.bottom),
            stroke: e.FINAL_CONFIG.chart.highlighter.color,
            "stroke-width": e.FINAL_CONFIG.chart.highlighter.lineWidth,
            "stroke-dasharray": e.FINAL_CONFIG.chart.highlighter.lineDasharray,
            "stroke-linecap": "round",
            style: { transition: "none !important", animation: "none !important", "pointer-events": "none" }
          }, null, 8, Bt)
        ])) : c("", !0),
        e.FINAL_CONFIG.chart.grid.frame.show ? (a(), s("rect", {
          key: 3,
          style: { pointerEvents: "none", transition: "none" },
          x: e.drawingArea.left + e.xPadding < 0 ? 0 : e.drawingArea.left + e.xPadding,
          y: e.drawingArea.top,
          width: e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries) < 0 ? 0 : e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries),
          height: e.drawingArea.height < 0 ? 0 : e.drawingArea.height,
          fill: "transparent",
          stroke: e.FINAL_CONFIG.chart.grid.frame.stroke,
          "stroke-width": e.FINAL_CONFIG.chart.grid.frame.strokeWidth,
          "stroke-linecap": e.FINAL_CONFIG.chart.grid.frame.strokeLinecap,
          "stroke-linejoin": e.FINAL_CONFIG.chart.grid.frame.strokeLinejoin,
          "stroke-dasharray": e.FINAL_CONFIG.chart.grid.frame.strokeDasharray
        }, null, 8, Wt)) : c("", !0),
        e.FINAL_CONFIG.chart.grid.labels.show ? (a(), s("g", Et, [
          t.mutableConfig.useIndividualScale ? (a(), s(u, { key: 0 }, [
            (a(!0), s(u, null, m(e.allScales, (i) => (a(), s("g", null, [
              g("line", {
                x1: i.x + e.xPadding,
                x2: i.x + e.xPadding,
                y1: t.mutableConfig.isStacked ? e.forceValidValue(e.drawingArea.bottom - i.yOffset - i.individualHeight) : e.forceValidValue(e.drawingArea.top),
                y2: t.mutableConfig.isStacked ? e.forceValidValue(e.drawingArea.bottom - i.yOffset) : e.forceValidValue(e.drawingArea.bottom),
                stroke: i.color,
                "stroke-width": e.FINAL_CONFIG.chart.grid.stroke,
                "stroke-linecap": "round",
                style: O(`opacity:${t.selectedScale ? t.selectedScale === i.id ? 1 : 0.3 : 1};transition:opacity 0.2s ease-in-out`)
              }, null, 12, Yt)
            ]))), 256)),
            (a(!0), s(u, null, m(e.allScales, (i) => (a(), s("g", {
              style: O(`opacity:${t.selectedScale ? t.selectedScale === i.id ? 1 : 0.3 : 1};transition:opacity 0.2s ease-in-out`)
            }, [
              g("text", {
                fill: i.color,
                "font-size": t.fontSizes.dataLabels,
                "text-anchor": "middle",
                transform: `translate(${i.x - e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth + 5 + e.xPadding}, ${t.mutableConfig.isStacked ? e.drawingArea.bottom - i.yOffset - i.individualHeight / 2 : e.drawingArea.top + e.drawingArea.height / 2}) rotate(-90)`
              }, k(i.name) + " " + k(i.scaleLabel ? `- ${i.scaleLabel}` : ""), 9, qt),
              (a(!0), s(u, null, m(i.yLabels, (h, n) => (a(), s("line", {
                x1: i.x - 3 + e.xPadding,
                x2: i.x + e.xPadding,
                y1: e.forceValidValue(h.y),
                y2: e.forceValidValue(h.y),
                stroke: i.color,
                "stroke-width": 1,
                "stroke-linecap": "round"
              }, null, 8, Xt))), 256)),
              (a(!0), s(u, null, m(i.yLabels, (h, n) => (a(), s("text", {
                x: i.x - 5 + e.xPadding,
                y: e.forceValidValue(h.y) + t.fontSizes.dataLabels / 3,
                "font-size": t.fontSizes.dataLabels,
                "text-anchor": "end",
                fill: i.color
              }, k(e.applyDataLabel(
                e.FINAL_CONFIG.chart.grid.labels.yAxis.formatter,
                h.value,
                e.dataLabel({
                  p: h.prefix,
                  v: h.value,
                  s: h.suffix,
                  r: 1
                }),
                { datapoint: h.datapoint, seriesIndex: n }
              )), 9, Ut))), 256))
            ], 4))), 256))
          ], 64)) : (a(!0), s(u, { key: 1 }, m(e.yLabels, (i, h) => (a(), s("g", {
            key: `yLabel_${h}`
          }, [
            e.canShowValue(i) && i.value >= e.niceScale.min && i.value <= e.niceScale.max ? (a(), s("line", {
              key: 0,
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.left - 5 + e.xPadding,
              y1: e.forceValidValue(i.y),
              y2: e.forceValidValue(i.y),
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": "1",
              "stroke-linecap": "round"
            }, null, 8, Zt)) : c("", !0),
            i.value >= e.niceScale.min && i.value <= e.niceScale.max ? (a(), s("text", {
              key: 1,
              x: e.drawingArea.left - 7 + e.xPadding,
              y: e.checkNaN(i.y + t.fontSizes.dataLabels / 3),
              "font-size": t.fontSizes.dataLabels,
              "text-anchor": "end",
              fill: e.FINAL_CONFIG.chart.grid.labels.color
            }, k(e.canShowValue(i.value) ? e.applyDataLabel(
              e.FINAL_CONFIG.chart.grid.labels.yAxis.formatter,
              i.value,
              e.dataLabel({
                p: i.prefix,
                v: i.value,
                s: i.suffix,
                r: 1
              })
            ) : ""), 9, Jt)) : c("", !0)
          ]))), 128))
        ])) : c("", !0),
        (a(!0), s(u, null, m(e.plotSet, (i, h) => (a(), s("g", {
          key: `serie_plot_${h}`,
          class: B(`serie_plot_${h}`),
          style: O(`opacity:${t.selectedScale ? t.selectedScale === i.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (a(!0), s(u, null, m(i.plots, (n, f) => (a(), s("g", {
            key: `circle_plot_${h}_${f}`
          }, [
            n && e.canShowValue(n.value) ? (a(), H(b, {
              key: 0,
              shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(i.shape) ? i.shape : "circle",
              color: e.FINAL_CONFIG.plot.useGradient ? `url(#plotGradient_${h}_${t.uniqueId})` : e.FINAL_CONFIG.plot.dot.useSerieColor ? i.color : e.FINAL_CONFIG.plot.dot.fill,
              plot: { x: e.checkNaN(n.x), y: e.checkNaN(n.y) },
              radius: t.selectedSerieIndex !== null && t.selectedSerieIndex === f || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === f ? (t.plotRadii.plot || 6) * 1.5 : t.plotRadii.plot || 6,
              stroke: e.FINAL_CONFIG.plot.dot.useSerieColor ? e.FINAL_CONFIG.chart.backgroundColor : i.color,
              strokeWidth: e.FINAL_CONFIG.plot.dot.strokeWidth
            }, null, 8, ["shape", "color", "plot", "radius", "stroke", "strokeWidth"])) : c("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (a(), s("foreignObject", {
              key: 1,
              style: { overflow: "visible" },
              height: "12",
              width: e.FINAL_CONFIG.chart.comments.width,
              x: n.x - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: n.y + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              g("div", Kt, [
                S(r.$slots, "plot-comment", {
                  plot: { ...n, color: i.color, seriesIndex: h, datapointIndex: f }
                }, void 0, !0)
              ])
            ], 8, Qt)) : c("", !0)
          ]))), 128)),
          Object.hasOwn(i, "useProgression") && i.useProgression === !0 && !isNaN(e.calcLinearProgression(i.plots).trend) ? (a(), s("g", jt, [
            g("defs", null, [
              g("marker", {
                id: `plot_arrow_${h}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                g("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: i.color
                }, null, 8, er)
              ], 8, $t)
            ]),
            i.plots.length > 1 ? (a(), s("line", {
              key: 0,
              x1: e.calcLinearProgression(i.plots).x1,
              x2: e.calcLinearProgression(i.plots).x2,
              y1: e.forceValidValue(e.calcLinearProgression(i.plots).y1),
              y2: e.forceValidValue(e.calcLinearProgression(i.plots).y2),
              "stroke-width": 1,
              stroke: i.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#plot_arrow_${h})`
            }, null, 8, tr)) : c("", !0),
            i.plots.length > 1 ? (a(), s("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(i.plots).x2,
              y: e.calcLinearProgression(i.plots).y2 - 6,
              "font-size": t.fontSizes.plotLabels,
              fill: i.color
            }, k(e.dataLabel({
              v: e.calcLinearProgression(i.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, rr)) : c("", !0)
          ])) : c("", !0)
        ], 6))), 128)),
        (a(!0), s(u, null, m(e.lineSet, (i, h) => (a(), s("g", {
          key: `serie_line_${h}`,
          class: B(`serie_line_${h}`),
          style: O(`opacity:${t.selectedScale ? t.selectedScale === i.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          i.smooth && i.plots.length > 1 ? (a(), s("path", {
            key: 0,
            d: `M${i.curve}`,
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            "stroke-width": e.FINAL_CONFIG.line.strokeWidth + 1,
            "stroke-dasharray": i.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
            fill: "none"
          }, null, 8, ir)) : i.plots.length > 1 ? (a(), s("path", {
            key: 1,
            d: `M${i.straight}`,
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            "stroke-width": e.FINAL_CONFIG.line.strokeWidth + 1,
            "stroke-dasharray": i.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
            fill: "none",
            "stroke-linecap": "round",
            "stroke-linejoin": "round"
          }, null, 8, ar)) : c("", !0)
        ], 6))), 128)),
        r.$slots.pattern ? (a(), s("defs", lr, [
          (a(!0), s(u, null, m(e.safeDataset, (i, h) => S(r.$slots, "pattern", J({
            key: `serie_pattern_slot_${h}`
          }, { ...i, seriesIndex: i.slotAbsoluteIndex, patternId: `pattern_${t.uniqueId}_${h}` }), void 0, !0)), 128))
        ])) : c("", !0),
        (a(!0), s(u, null, m(e.lineSet, (i, h) => (a(), s("g", {
          key: `serie_line_${h}`,
          class: B(`serie_line_${h}`),
          style: O(`opacity:${t.selectedScale ? t.selectedScale === i.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          i.useArea && i.plots.length > 1 ? (a(), s("g", sr, [
            i.smooth ? (a(), s(u, { key: 0 }, [
              g("path", {
                d: `M ${i.plots[0] ? i.plots[0].x : Math.min(...i.plots.filter((n) => !!n).map((n) => n.x))},${t.mutableConfig.isStacked ? e.drawingArea.bottom - i.yOffset : e.drawingArea.bottom} ${i.curve} L ${i.plots.at(-1) ? i.plots.at(-1).x : e.drawingArea.left + e.slot.line * h + e.slot.line / 2},${t.mutableConfig.isStacked ? e.drawingArea.bottom - i.yOffset : e.drawingArea.bottom} Z`,
                fill: e.FINAL_CONFIG.line.area.useGradient ? `url(#areaGradient_${h}_${t.uniqueId})` : e.setOpacity(i.color, e.FINAL_CONFIG.line.area.opacity)
              }, null, 8, nr),
              r.$slots.pattern ? (a(), s("path", {
                key: 0,
                d: `M ${i.plots[0] ? i.plots[0].x : Math.min(...i.plots.filter((n) => !!n).map((n) => n.x))},${t.mutableConfig.isStacked ? e.drawingArea.bottom - i.yOffset : e.drawingArea.bottom} ${i.curve} L ${i.plots.at(-1) ? i.plots.at(-1).x : e.drawingArea.left + e.slot.line * h + e.slot.line / 2},${t.mutableConfig.isStacked ? e.drawingArea.bottom - i.yOffset : e.drawingArea.bottom} Z`,
                fill: `url(#pattern_${t.uniqueId}_${i.slotAbsoluteIndex})`
              }, null, 8, hr)) : c("", !0)
            ], 64)) : (a(), s(u, { key: 1 }, [
              g("path", {
                d: `M${i.area}Z`,
                fill: e.FINAL_CONFIG.line.area.useGradient ? `url(#areaGradient_${h}_${t.uniqueId})` : e.setOpacity(i.color, e.FINAL_CONFIG.line.area.opacity)
              }, null, 8, or),
              r.$slots.pattern ? (a(), s("path", {
                key: 0,
                d: `M${i.area}Z`,
                fill: `url(#pattern_${t.uniqueId}_${i.slotAbsoluteIndex})`
              }, null, 8, cr)) : c("", !0)
            ], 64))
          ])) : c("", !0),
          i.smooth && i.plots.length > 1 ? (a(), s("path", {
            key: 1,
            d: `M${i.curve}`,
            stroke: i.color,
            "stroke-width": e.FINAL_CONFIG.line.strokeWidth,
            "stroke-dasharray": i.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
            fill: "none",
            "stroke-linecap": "round"
          }, null, 8, dr)) : i.plots.length > 1 ? (a(), s("path", {
            key: 2,
            d: `M${i.straight}`,
            stroke: i.color,
            "stroke-width": e.FINAL_CONFIG.line.strokeWidth,
            "stroke-dasharray": i.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
            fill: "none",
            "stroke-linecap": "round",
            "stroke-linejoin": "round"
          }, null, 8, ur)) : c("", !0),
          (a(!0), s(u, null, m(i.plots, (n, f) => (a(), s(u, {
            key: `circle_line_${h}_${f}`
          }, [
            !e.optimize.linePlot && n && e.canShowValue(n.value) || e.optimize.linePlot && n && e.canShowValue(n.value) && (t.selectedSerieIndex !== null && t.selectedSerieIndex === f || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === f) ? (a(), H(b, {
              key: 0,
              shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(i.shape) ? i.shape : "circle",
              color: e.FINAL_CONFIG.line.useGradient ? `url(#lineGradient_${h}_${t.uniqueId})` : e.FINAL_CONFIG.line.dot.useSerieColor ? i.color : e.FINAL_CONFIG.line.dot.fill,
              plot: { x: e.checkNaN(n.x), y: e.checkNaN(n.y) },
              radius: t.selectedSerieIndex !== null && t.selectedSerieIndex === f || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === f ? (t.plotRadii.line || 6) * 1.5 : t.plotRadii.line || 6,
              stroke: e.FINAL_CONFIG.line.dot.useSerieColor ? e.FINAL_CONFIG.chart.backgroundColor : i.color,
              strokeWidth: e.FINAL_CONFIG.line.dot.strokeWidth
            }, null, 8, ["shape", "color", "plot", "radius", "stroke", "strokeWidth"])) : c("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (a(), s("foreignObject", {
              key: 1,
              style: { overflow: "visible" },
              height: "12",
              width: e.FINAL_CONFIG.chart.comments.width,
              x: n.x - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: n.y + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              g("div", fr, [
                S(r.$slots, "plot-comment", {
                  plot: { ...n, color: i.color, seriesIndex: h, datapointIndex: f }
                }, void 0, !0)
              ])
            ], 8, gr)) : c("", !0)
          ], 64))), 128)),
          Object.hasOwn(i, "useProgression") && i.useProgression === !0 && !isNaN(e.calcLinearProgression(i.plots).trend) ? (a(), s("g", Ir, [
            g("defs", null, [
              g("marker", {
                id: `line_arrow_${h}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                g("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: i.color
                }, null, 8, Nr)
              ], 8, mr)
            ]),
            i.plots.length > 1 ? (a(), s("line", {
              key: 0,
              x1: e.calcLinearProgression(i.plots).x1,
              x2: e.calcLinearProgression(i.plots).x2,
              y1: e.forceValidValue(e.calcLinearProgression(i.plots).y1),
              y2: e.forceValidValue(e.calcLinearProgression(i.plots).y2),
              "stroke-width": 1,
              stroke: i.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#line_arrow_${h})`
            }, null, 8, xr)) : c("", !0),
            i.plots.length > 1 ? (a(), s("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(i.plots).x2,
              y: e.calcLinearProgression(i.plots).y2 - 6,
              "font-size": t.fontSizes.plotLabels,
              fill: i.color
            }, k(e.dataLabel({
              v: e.calcLinearProgression(i.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, br)) : c("", !0)
          ])) : c("", !0)
        ], 6))), 128)),
        (e.FINAL_CONFIG.bar.labels.show || e.FINAL_CONFIG.bar.serieName.show) && t.mutableConfig.dataLabels.show ? (a(), s("g", Fr, [
          (a(!0), s(u, null, m(e.barSet, (i, h) => (a(), s(u, {
            key: `xLabel_bar_${h}`
          }, [
            (a(!0), s(u, null, m(i.plots, (n, f) => (a(), s(u, {
              key: `xLabel_bar_${h}_${f}`
            }, [
              n && (!Object.hasOwn(i, "dataLabels") || i.dataLabels === !0 || t.selectedSerieIndex !== null && t.selectedSerieIndex === f || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === f) && e.FINAL_CONFIG.bar.labels.show ? (a(), s("text", {
                key: 0,
                x: t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? n.x + e.slot.line / 2 : e.calcRectX(n) + e.calcRectWidth() / 2 - e.barPeriodGap / 2,
                y: e.checkNaN(n.y) + (n.value >= 0 ? e.FINAL_CONFIG.bar.labels.offsetY : -e.FINAL_CONFIG.bar.labels.offsetY * 3),
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.bar.labels.color
              }, k(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.bar.labels.formatter,
                n.value,
                e.dataLabel({
                  p: i.prefix || e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: i.suffix || e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.bar.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: i
                }
              ) : ""), 9, _r)) : c("", !0),
              n && e.FINAL_CONFIG.bar.serieName.show ? (a(), s("text", {
                key: 1,
                x: t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? n.x + e.slot.line / 2 : n.x + e.calcRectWidth() * 1.1,
                y: n.y + (n.value > 0 ? e.FINAL_CONFIG.bar.serieName.offsetY : -e.FINAL_CONFIG.bar.serieName.offsetY * 3),
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.bar.serieName.useSerieColor ? i.color : e.FINAL_CONFIG.bar.serieName.color,
                "font-weight": e.FINAL_CONFIG.bar.serieName.bold ? "bold" : "normal"
              }, k(e.FINAL_CONFIG.bar.serieName.useAbbreviation ? e.abbreviate({ source: i.name, length: e.FINAL_CONFIG.bar.serieName.abbreviationSize }) : i.name), 9, Ar)) : c("", !0)
            ], 64))), 128))
          ], 64))), 128))
        ])) : c("", !0),
        e.FINAL_CONFIG.plot.labels.show && t.mutableConfig.dataLabels.show ? (a(), s("g", yr, [
          (a(!0), s(u, null, m(e.plotSet, (i, h) => (a(), s(u, {
            key: `xLabel_plot_${h}`
          }, [
            (a(!0), s(u, null, m(i.plots, (n, f) => (a(), s(u, {
              key: `xLabel_plot_${h}_${f}`
            }, [
              n && !Object.hasOwn(i, "dataLabels") || i.dataLabels === !0 || t.selectedSerieIndex !== null && t.selectedSerieIndex === f || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === f ? (a(), s("text", {
                key: 0,
                x: n.x,
                y: n.y + e.FINAL_CONFIG.plot.labels.offsetY,
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.plot.labels.color
              }, k(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.plot.labels.formatter,
                n.value,
                e.dataLabel({
                  p: i.prefix || e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: i.suffix || e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.plot.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: i
                }
              ) : ""), 9, Cr)) : c("", !0),
              n && f === 0 && i.useTag && i.useTag === "start" ? (a(), s("foreignObject", {
                key: 1,
                x: n.x,
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                g("div", {
                  style: O(`padding: 3px; background:${e.setOpacity(i.color, 80)};color:${e.adaptColorToBackground(i.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, k(i.name), 5)
              ], 8, Lr)) : c("", !0),
              n && f === i.plots.length - 1 && i.useTag && i.useTag === "end" ? (a(), s("foreignObject", {
                key: 2,
                x: n.x - i.name.length * (t.fontSizes.plotLabels / 2),
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                g("div", {
                  style: O(`padding: 3px; background:${e.setOpacity(i.color, 80)};color:${e.adaptColorToBackground(i.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, k(i.name), 5)
              ], 8, Sr)) : c("", !0)
            ], 64))), 128))
          ], 64))), 128))
        ])) : c("", !0),
        e.FINAL_CONFIG.line.labels.show && t.mutableConfig.dataLabels.show ? (a(), s("g", kr, [
          (a(!0), s(u, null, m(e.lineSet, (i, h) => (a(), s(u, {
            key: `xLabel_line_${h}`
          }, [
            (a(!0), s(u, null, m(i.plots, (n, f) => (a(), s(u, {
              key: `xLabel_line_${h}_${f}`
            }, [
              n && !Object.hasOwn(i, "dataLabels") || i.dataLabels === !0 || t.selectedSerieIndex !== null && t.selectedSerieIndex === f || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === f ? (a(), s("text", {
                key: 0,
                x: n.x,
                y: n.y + (n.value >= 0 ? e.FINAL_CONFIG.line.labels.offsetY : -e.FINAL_CONFIG.line.labels.offsetY * 3),
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.line.labels.color
              }, k(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.line.labels.formatter,
                n.value,
                e.dataLabel({
                  p: i.prefix || e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: i.suffix || e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.line.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: i
                }
              ) : ""), 9, wr)) : c("", !0),
              n && f === 0 && i.useTag && i.useTag === "start" ? (a(), s("foreignObject", {
                key: 1,
                x: n.x,
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                g("div", {
                  style: O(`padding: 3px; background:${e.setOpacity(i.color, 80)};color:${e.adaptColorToBackground(i.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, k(i.name), 5)
              ], 8, Or)) : c("", !0),
              n && f === i.plots.length - 1 && i.useTag && i.useTag === "end" ? (a(), s("foreignObject", {
                key: 2,
                x: n.x - i.name.length * (t.fontSizes.plotLabels / 2),
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                g("div", {
                  style: O(`padding: 3px; background:${e.setOpacity(i.color, 80)};color:${e.adaptColorToBackground(i.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, k(i.name), 5)
              ], 8, Gr)) : c("", !0)
            ], 64))), 128))
          ], 64))), 128))
        ])) : c("", !0),
        (a(!0), s(u, null, m(e.lineSet, (i, h) => (a(), s(u, {
          key: `xLabel_line_${h}`
        }, [
          (a(!0), s(u, null, m(i.plots, (n, f) => (a(), s(u, {
            key: `xLabel_line_${h}_${f}`
          }, [
            n && f === 0 && i.showSerieName && i.showSerieName === "start" ? (a(), s("text", {
              key: 0,
              x: n.x - t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "end",
              fill: i.color,
              innerHTML: e.createTSpans({
                content: i.name,
                fontSize: t.fontSizes.plotLabels,
                fill: i.color,
                x: n.x - t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, vr)) : c("", !0),
            n && f === i.plots.length - 1 && i.showSerieName && i.showSerieName === "end" ? (a(), s("text", {
              key: 1,
              x: n.x + t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "start",
              fill: i.color,
              innerHTML: e.createTSpans({
                content: i.name,
                fontSize: t.fontSizes.plotLabels,
                fill: i.color,
                x: n.x + t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, zr)) : c("", !0)
          ], 64))), 128))
        ], 64))), 128)),
        (a(!0), s(u, null, m(e.plotSet, (i, h) => (a(), s(u, {
          key: `xLabel_plot_${h}`
        }, [
          (a(!0), s(u, null, m(i.plots, (n, f) => (a(), s(u, {
            key: `xLabel_plot_${h}_${f}`
          }, [
            n && f === 0 && i.showSerieName && i.showSerieName === "start" ? (a(), s("text", {
              key: 0,
              x: n.x - t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "end",
              fill: i.color,
              innerHTML: e.createTSpans({
                content: i.name,
                fontSize: t.fontSizes.plotLabels,
                fill: i.color,
                x: n.x - t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, Mr)) : c("", !0),
            n && f === i.plots.length - 1 && i.showSerieName && i.showSerieName === "end" ? (a(), s("text", {
              key: 1,
              x: n.x + t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "start",
              fill: i.color,
              innerHTML: e.createTSpans({
                content: i.name,
                fontSize: t.fontSizes.plotLabels,
                fill: i.color,
                x: n.x + t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, pr)) : c("", !0)
          ], 64))), 128))
        ], 64))), 128)),
        t.mutableConfig.useIndividualScale && !t.mutableConfig.isStacked ? (a(!0), s(u, { key: 9 }, m(e.allScales, (i) => (a(), s("rect", {
          x: i.x - e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth + e.xPadding,
          y: e.drawingArea.top,
          width: e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth,
          height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
          fill: t.selectedScale === i.id ? e.setOpacity(i.color, 20) : "transparent",
          onMouseenter: (h) => t.selectedScale = i.id,
          onMouseleave: l[0] || (l[0] = (h) => t.selectedScale = null)
        }, null, 40, Tr))), 256)) : c("", !0),
        g("g", null, [
          e.FINAL_CONFIG.chart.grid.labels.axis.yLabel && !t.mutableConfig.useIndividualScale ? (a(), s("text", {
            key: 0,
            "font-size": t.fontSizes.yAxis,
            fill: e.FINAL_CONFIG.chart.grid.labels.color,
            transform: `translate(${t.fontSizes.yAxis + e.FINAL_CONFIG.chart.grid.labels.axis.yLabelOffsetX}, ${e.drawingArea.top + e.drawingArea.height / 2}) rotate(-90)`,
            "text-anchor": "middle",
            style: { transition: "none" }
          }, k(e.FINAL_CONFIG.chart.grid.labels.axis.yLabel), 9, Pr)) : c("", !0),
          e.FINAL_CONFIG.chart.grid.labels.axis.xLabel ? (a(), s("text", {
            key: 1,
            "text-anchor": "middle",
            x: t.width / 2,
            y: e.drawingArea.bottom + t.fontSizes.yAxis + t.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.axis.xLabelOffsetY,
            "font-size": t.fontSizes.yAxis,
            fill: e.FINAL_CONFIG.chart.grid.labels.color
          }, k(e.FINAL_CONFIG.chart.grid.labels.axis.xLabel), 9, Vr)) : c("", !0)
        ]),
        Q('v-for="(label, i) in timeLabels" :key="`time_label_${i}`" '),
        e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.show ? (a(), s("g", Rr, [
          r.$slots["time-label"] ? (a(!0), s(u, { key: 0 }, m(e.timeLabels, (i, h) => S(r.$slots, "time-label", W(J({
            key: `time_label_${h}`
          }, {
            x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * h + e.drawingArea.width / e.maxSeries / 2,
            y: e.drawingArea.bottom + t.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.yOffset,
            fontSize: t.fontSizes.xAxis,
            fill: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.color,
            transform: `translate(${e.drawingArea.left + e.drawingArea.width / e.maxSeries * h + e.drawingArea.width / e.maxSeries / 2}, ${e.drawingArea.bottom + t.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.yOffset}), rotate(${e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation})`,
            absoluteIndex: i.absoluteIndex,
            content: i.text,
            textAnchor: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation > 0 ? "start" : e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation < 0 ? "end" : "middle",
            show: i && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || i && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && (h === 0 || h === e.timeLabels.length - 1) && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || i && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && t.selectedSerieIndex === h && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || i && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo && h % Math.floor((this.slicer.end - this.slicer.start) / e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.modulo) === 0
          })), void 0, !0)), 128)) : (a(!0), s(u, { key: 1 }, m(e.timeLabels, (i, h) => (a(), s("g", {
            key: `time_label_${h}`
          }, [
            i && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || i && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && (h === 0 || h === e.timeLabels.length - 1) && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || i && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && t.selectedSerieIndex === h && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || i && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo && h % Math.floor((this.slicer.end - this.slicer.start) / e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.modulo) === 0 ? (a(), s("text", {
              key: 0,
              "text-anchor": e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation > 0 ? "start" : e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation < 0 ? "end" : "middle",
              "font-size": t.fontSizes.xAxis,
              fill: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.color,
              transform: `translate(${e.drawingArea.left + e.drawingArea.width / e.maxSeries * h + e.drawingArea.width / e.maxSeries / 2}, ${e.drawingArea.bottom + t.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.yOffset}), rotate(${e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation})`,
              style: {
                cursor: "pointer"
              },
              onClick: () => e.selectTimeLabel(i, h)
            }, k(i.text || ""), 9, Dr)) : c("", !0)
          ]))), 128))
        ])) : c("", !0),
        g("g", null, [
          (a(!0), s(u, null, m(e.maxSeries, (i, h) => (a(), s("rect", {
            key: `tooltip_trap_${h}`,
            "data-cy-trap": "",
            x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * h,
            y: e.drawingArea.top,
            height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
            width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
            fill: "transparent",
            onMouseenter: (n) => e.toggleTooltipVisibility(!0, h),
            onMouseleave: l[1] || (l[1] = (n) => e.toggleTooltipVisibility(!1)),
            onClick: (n) => e.selectX(h)
          }, null, 40, Hr))), 128))
        ]),
        e.FINAL_CONFIG.chart.timeTag.show && (![null, void 0].includes(t.selectedSerieIndex) || ![null, void 0].includes(t.selectedMinimapIndex)) ? (a(), s("g", Br, [
          (a(), s("foreignObject", {
            x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * ((t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)) - 100 + e.drawingArea.width / e.maxSeries / 2,
            y: e.drawingArea.bottom,
            width: "200",
            height: "40",
            style: { overflow: "visible !important" }
          }, [
            g("div", {
              class: "vue-ui-xy-time-tag",
              style: O(`width: fit-content;margin: 0 auto;text-align:center;padding:3px 12px;background:${e.FINAL_CONFIG.chart.timeTag.backgroundColor};color:${e.FINAL_CONFIG.chart.timeTag.color};font-size:${e.FINAL_CONFIG.chart.timeTag.fontSize}px`)
            }, k(e.timeLabels[(t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)].text || (t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)), 5)
          ], 8, Wr)),
          g("circle", {
            cx: e.drawingArea.left + e.drawingArea.width / e.maxSeries * ((t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)) + e.drawingArea.width / e.maxSeries / 2,
            cy: e.drawingArea.bottom,
            r: e.FINAL_CONFIG.chart.timeTag.circleMarker.radius,
            fill: e.FINAL_CONFIG.chart.timeTag.circleMarker.color
          }, null, 8, Er)
        ])) : c("", !0)
      ])) : c("", !0),
      S(r.$slots, "svg", { svg: e.svg }, void 0, !0)
    ], 14, $e)) : c("", !0),
    r.$slots.watermark ? (a(), s("div", Yr, [
      S(r.$slots, "watermark", W(Y({ isPrinting: t.isPrinting || t.isImaging })), void 0, !0)
    ])) : c("", !0),
    e.isDataset ? c("", !0) : (a(), H(V, {
      key: 6,
      config: {
        type: "line",
        style: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          line: {
            axis: {
              color: e.FINAL_CONFIG.chart.grid.stroke
            },
            path: {
              color: e.FINAL_CONFIG.chart.grid.stroke,
              strokeWidth: 0.5
            }
          }
        }
      }
    }, null, 8, ["config"])),
    e.FINAL_CONFIG.chart.zoom.show && t.maxX > 6 && e.isDataset ? (a(), H(v, {
      ref: "chartSlicer",
      key: `slicer_${t.slicerStep}`,
      background: e.FINAL_CONFIG.chart.zoom.color,
      fontSize: e.FINAL_CONFIG.chart.zoom.fontSize,
      useResetSlot: e.FINAL_CONFIG.chart.zoom.useResetSlot,
      labelLeft: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[t.slicer.start],
      labelRight: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[t.slicer.end - 1],
      textColor: e.FINAL_CONFIG.chart.color,
      inputColor: e.FINAL_CONFIG.chart.zoom.color,
      selectColor: e.FINAL_CONFIG.chart.zoom.highlightColor,
      borderColor: e.FINAL_CONFIG.chart.backgroundColor,
      minimap: e.minimap,
      smoothMinimap: e.FINAL_CONFIG.chart.zoom.minimap.smooth,
      minimapSelectedColor: e.FINAL_CONFIG.chart.zoom.minimap.selectedColor,
      minimapSelectionRadius: e.FINAL_CONFIG.chart.zoom.minimap.selectionRadius,
      minimapLineColor: e.FINAL_CONFIG.chart.zoom.minimap.lineColor,
      minimapSelectedColorOpacity: e.FINAL_CONFIG.chart.zoom.minimap.selectedColorOpacity,
      minimapSelectedIndex: t.selectedSerieIndex,
      minimapIndicatorColor: e.FINAL_CONFIG.chart.zoom.minimap.indicatorColor,
      verticalHandles: e.FINAL_CONFIG.chart.zoom.minimap.verticalHandles,
      max: t.maxX,
      min: 0,
      valueStart: t.slicer.start,
      valueEnd: t.slicer.end,
      start: t.slicer.start,
      "onUpdate:start": l[2] || (l[2] = (i) => t.slicer.start = i),
      end: t.slicer.end,
      "onUpdate:end": l[3] || (l[3] = (i) => t.slicer.end = i),
      refreshStartPoint: e.FINAL_CONFIG.chart.zoom.startIndex !== null ? e.FINAL_CONFIG.chart.zoom.startIndex : 0,
      refreshEndPoint: e.FINAL_CONFIG.chart.zoom.endIndex !== null ? e.FINAL_CONFIG.chart.zoom.endIndex + 1 : Math.max(...o.dataset.map((i) => e.largestTriangleThreeBucketsArray({ data: i.series, threshold: e.FINAL_CONFIG.downsample.threshold }).length)),
      enableRangeHandles: e.FINAL_CONFIG.chart.zoom.enableRangeHandles,
      enableSelectionDrag: e.FINAL_CONFIG.chart.zoom.enableSelectionDrag,
      onReset: e.refreshSlicer,
      onTrapMouse: e.selectMinimapIndex
    }, {
      "reset-action": P(({ reset: i }) => [
        S(r.$slots, "reset-action", W(Y({ reset: i })), void 0, !0)
      ]),
      _: 3
    }, 8, ["background", "fontSize", "useResetSlot", "labelLeft", "labelRight", "textColor", "inputColor", "selectColor", "borderColor", "minimap", "smoothMinimap", "minimapSelectedColor", "minimapSelectionRadius", "minimapLineColor", "minimapSelectedColorOpacity", "minimapSelectedIndex", "minimapIndicatorColor", "verticalHandles", "max", "valueStart", "valueEnd", "start", "end", "refreshStartPoint", "refreshEndPoint", "enableRangeHandles", "enableSelectionDrag", "onReset", "onTrapMouse"])) : c("", !0),
    e.FINAL_CONFIG.chart.legend.show ? (a(), s("div", {
      key: 8,
      ref: "chartLegend",
      class: "vue-ui-xy-legend",
      style: O(`font-size:${e.FINAL_CONFIG.chart.legend.fontSize}px`)
    }, [
      (a(!0), s(u, null, m(e.absoluteDataset, (i, h) => (a(), s("div", {
        key: `div_legend_item_${h}`,
        onClick: (n) => e.segregate(i),
        class: B({ "vue-ui-xy-legend-item": !0, "vue-ui-xy-legend-item-segregated": t.segregatedSeries.includes(i.id) })
      }, [
        t.icons[i.type] === "line" ? (a(), s("svg", Xr, [
          g("rect", {
            x: "0",
            y: "7.5",
            rx: "1.5",
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            "stroke-width": 0.5,
            height: "3",
            width: "20",
            fill: i.color
          }, null, 8, Ur),
          q(b, {
            plot: { x: 10, y: 9 },
            radius: 4,
            color: i.color,
            shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(i.shape) ? i.shape : "circle",
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            strokeWidth: 0.5
          }, null, 8, ["color", "shape", "stroke"])
        ])) : t.icons[i.type] === "bar" ? (a(), s("svg", Zr, [
          t.icons[i.type] === "bar" && r.$slots.pattern ? (a(), s("rect", {
            key: 0,
            x: "0",
            y: "0",
            rx: "1",
            height: "40",
            width: "40",
            stroke: "none",
            fill: i.color
          }, null, 8, Jr)) : c("", !0),
          t.icons[i.type] === "bar" ? (a(), s("rect", {
            key: 1,
            x: "0",
            y: "0",
            rx: "1",
            height: "40",
            width: "40",
            stroke: "none",
            fill: r.$slots.pattern ? `url(#pattern_${t.uniqueId}_${i.slotAbsoluteIndex})` : i.color
          }, null, 8, Qr)) : c("", !0)
        ])) : (a(), s("svg", Kr, [
          q(b, {
            plot: { x: 6, y: 6 },
            radius: 5,
            color: i.color,
            shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(i.shape) ? i.shape : "circle"
          }, null, 8, ["color", "shape"])
        ])),
        g("span", {
          style: O(`color:${e.FINAL_CONFIG.chart.legend.color}`)
        }, k(i.name), 5)
      ], 10, qr))), 128))
    ], 4)) : (a(), s("div", jr, [
      S(r.$slots, "legend", { legend: e.absoluteDataset }, void 0, !0)
    ], 512)),
    r.$slots.source ? (a(), s("div", $r, [
      S(r.$slots, "source", {}, void 0, !0)
    ], 512)) : c("", !0),
    q(z, {
      show: t.mutableConfig.showTooltip && t.isTooltip,
      backgroundColor: e.FINAL_CONFIG.chart.tooltip.backgroundColor,
      color: e.FINAL_CONFIG.chart.tooltip.color,
      fontSize: e.FINAL_CONFIG.chart.tooltip.fontSize,
      borderRadius: e.FINAL_CONFIG.chart.tooltip.borderRadius,
      borderColor: e.FINAL_CONFIG.chart.tooltip.borderColor,
      borderWidth: e.FINAL_CONFIG.chart.tooltip.borderWidth,
      backgroundOpacity: e.FINAL_CONFIG.chart.tooltip.backgroundOpacity,
      position: e.FINAL_CONFIG.chart.tooltip.position,
      offsetY: e.FINAL_CONFIG.chart.tooltip.offsetY,
      parent: r.$refs.chart,
      content: e.tooltipContent,
      isFullscreen: t.isFullscreen,
      isCustom: e.FINAL_CONFIG.chart.tooltip.customFormat && typeof e.FINAL_CONFIG.chart.tooltip.customFormat == "function"
    }, {
      "tooltip-before": P(() => [
        S(r.$slots, "tooltip-before", W(Y({ ...e.dataTooltipSlot })), void 0, !0)
      ]),
      "tooltip-after": P(() => [
        S(r.$slots, "tooltip-after", W(Y({ ...e.dataTooltipSlot })), void 0, !0)
      ]),
      _: 3
    }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "position", "offsetY", "parent", "content", "isFullscreen", "isCustom"]),
    e.isDataset ? (a(), H(T, {
      key: 11,
      hideDetails: "",
      config: {
        open: t.mutableConfig.showTable,
        maxHeight: 1e4,
        body: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          color: e.FINAL_CONFIG.chart.color
        },
        head: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          color: e.FINAL_CONFIG.chart.color
        }
      }
    }, {
      content: P(() => [
        g("div", {
          style: O(`${t.isPrinting ? "" : "max-height:400px"};overflow:auto;width:100%;margin-top:48px`)
        }, [
          g("div", ei, [
            Xe(g("input", {
              type: "checkbox",
              "onUpdate:modelValue": l[4] || (l[4] = (i) => t.showSparklineTable = i)
            }, null, 512), [
              [Ue, t.showSparklineTable]
            ]),
            g("div", {
              onClick: l[5] || (l[5] = (i) => t.showSparklineTable = !t.showSparklineTable),
              style: { cursor: "pointer" }
            }, [
              q(G, {
                name: "chartLine",
                size: 20,
                stroke: e.FINAL_CONFIG.chart.color
              }, null, 8, ["stroke"])
            ])
          ]),
          t.showSparklineTable ? (a(), H(F, {
            key: `sparkline_${t.segregateStep}`,
            dataset: e.tableSparklineDataset,
            config: e.tableSparklineConfig
          }, null, 8, ["dataset", "config"])) : (a(), H(C, {
            key: `table_${t.tableStep}`,
            colNames: e.dataTable.colNames,
            head: e.dataTable.head,
            body: e.dataTable.body,
            config: e.dataTable.config,
            title: `${e.FINAL_CONFIG.chart.title.text}${e.FINAL_CONFIG.chart.title.subtitle.text ? ` : ${e.FINAL_CONFIG.chart.title.subtitle.text}` : ""}`,
            onClose: l[6] || (l[6] = (i) => t.mutableConfig.showTable = !1)
          }, {
            th: P(({ th: i }) => [
              g("div", { innerHTML: i }, null, 8, ti)
            ]),
            td: P(({ td: i }) => [
              Q(k(isNaN(Number(i)) ? i : e.dataLabel({
                p: e.FINAL_CONFIG.chart.labels.prefix,
                v: i,
                s: e.FINAL_CONFIG.chart.labels.suffix,
                r: e.FINAL_CONFIG.table.rounding
              })), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ], 4)
      ]),
      _: 1
    }, 8, ["config"])) : c("", !0)
  ], 46, Ke);
}
const bi = /* @__PURE__ */ Ze(Qe, [["render", ri], ["__scopeId", "data-v-2ea54cd5"]]);
export {
  bi as default
};
